(***********************************************

          DaVinchi sript engine

    (C) Alexander Myasnikov, 2004-2009 

       Web: www.darksoftware.narod.ru

************************************************)

{$R-}
{$Q-}
{$D-}

unit daVinchi;

interface

uses
  SrchUnit,
  SysUtils,
  Classes,
  Math,
  Windows, Variants, ShlObj, inifiles, strutils, Dialogs, dateutils, darkregistry, Forms;

const
  minlongint = -2147483648;

const
  maxlongint = 2147483647;

const
  maxlongword = 4294967295;

const
  minlongword = 0;

(******* Stack state constants **************)

const
  DVerror = -1;

const
  DVok = 0;

const
  DVmm = -2;

const
  DVbb = -3;

var
  wantexit: boolean = False;

(********************************************)
function Pos (substr, str: string): integer;
function PosEx (substr, str: string; off: integer): integer;
function fixenv (s: string): string;

type
  Tdebug = procedure (log: string; err: boolean);

type
  Pdebug = ^Tdebug;

type
  tvarstyle = (_pint, _pword, _word, _int, _str, _bool, _err);

type
  tvartyp = (_label, _var);

type
  TVarProc0 = procedure ();

type
  TVarProc1 = procedure (x: cardinal);

type
  TVarProc2 = procedure (x1, x2: cardinal);

type
  TVarProc3 = procedure (x1, x2, x3: cardinal);

type
  TVarProc4 = procedure (x1, x2, x3, x4: cardinal);

type
  TVarProc5 = procedure (x1, x2, x3, x4, x5: cardinal);

type
  TVarProc6 = procedure (x1, x2, x3, x4, x5, x6: cardinal);

type
  TVarProc7 = procedure (x1, x2, x3, x4, x5, x6, x7: cardinal);


type
  TVarFunc0s = function (): string;

type
  TVarFunc1s = function (x1: cardinal): string;

type
  TVarFunc2s = function (x1, x2: cardinal): string;

type
  TVarFunc3s = function (x1, x2, x3: cardinal): string;

type
  TVarFunc4s = function (x1, x2, x3, x4: cardinal): string;

type
  TVarFunc5s = function (x1, x2, x3, x4, x5: cardinal): string;

type
  TVarFunc6s = function (x1, x2, x3, x4, x5, x6: cardinal): string;

type
  TVarFunc7s = function (x1, x2, x3, x4, x5, x6, x7: cardinal): string;


type
  TVarFunc0i = function (): cardinal;

type
  TVarFunc1i = function (x1: cardinal): cardinal;

type
  TVarFunc2i = function (x1, x2: cardinal): cardinal;

type
  TVarFunc3i = function (x1, x2, x3: cardinal): cardinal;

type
  TVarFunc4i = function (x1, x2, x3, x4: cardinal): cardinal;

type
  TVarFunc5i = function (x1, x2, x3, x4, x5: cardinal): cardinal;

type
  TVarFunc6i = function (x1, x2, x3, x4, x5, x6: cardinal): cardinal;

type
  TVarFunc7i = function (x1, x2, x3, x4, x5, x6, x7: cardinal): cardinal;


type
  TVarFunc0b = function (): boolean;

type
  TVarFunc1b = function (x1: cardinal): boolean;

type
  TVarFunc2b = function (x1, x2: cardinal): boolean;

type
  TVarFunc3b = function (x1, x2, x3: cardinal): boolean;

type
  TVarFunc4b = function (x1, x2, x3, x4: cardinal): boolean;

type
  TVarFunc5b = function (x1, x2, x3, x4, x5: cardinal): boolean;

type
  TVarFunc6b = function (x1, x2, x3, x4, x5, x6: cardinal): boolean;

type
  TVarFunc7b = function (x1, x2, x3, x4, x5, x6, x7: cardinal): boolean;


///////////////////
type
  TVarProc0ext = procedure (); stdcall;

type
  TVarProc1ext = procedure (x: cardinal); stdcall;

type
  TVarProc2ext = procedure (x1, x2: cardinal); stdcall;

type
  TVarProc3ext = procedure (x1, x2, x3: cardinal); stdcall;

type
  TVarProc4ext = procedure (x1, x2, x3, x4: cardinal); stdcall;

type
  TVarProc5ext = procedure (x1, x2, x3, x4, x5: cardinal); stdcall;

type
  TVarProc6ext = procedure (x1, x2, x3, x4, x5, x6: cardinal); stdcall;

type
  TVarProc7ext = procedure (x1, x2, x3, x4, x5, x6, x7: cardinal); stdcall;


type
  TVarFunc0sext = function (): string; stdcall;

type
  TVarFunc1sext = function (x1: cardinal): string; stdcall;

type
  TVarFunc2sext = function (x1, x2: cardinal): string; stdcall;

type
  TVarFunc3sext = function (x1, x2, x3: cardinal): string; stdcall;

type
  TVarFunc4sext = function (x1, x2, x3, x4: cardinal): string; stdcall;

type
  TVarFunc5sext = function (x1, x2, x3, x4, x5: cardinal): string; stdcall;

type
  TVarFunc6sext = function (x1, x2, x3, x4, x5, x6: cardinal): string; stdcall;

type
  TVarFunc7sext = function (x1, x2, x3, x4, x5, x6, x7: cardinal): string; stdcall;


type
  TVarFunc0iext = function (): cardinal; stdcall;

type
  TVarFunc1iext = function (x1: cardinal): cardinal; stdcall;

type
  TVarFunc2iext = function (x1, x2: cardinal): cardinal; stdcall;

type
  TVarFunc3iext = function (x1, x2, x3: cardinal): cardinal; stdcall;

type
  TVarFunc4iext = function (x1, x2, x3, x4: cardinal): cardinal; stdcall;

type
  TVarFunc5iext = function (x1, x2, x3, x4, x5: cardinal): cardinal; stdcall;

type
  TVarFunc6iext = function (x1, x2, x3, x4, x5, x6: cardinal): cardinal; stdcall;

type
  TVarFunc7iext = function (x1, x2, x3, x4, x5, x6, x7: cardinal): cardinal; stdcall;


type
  TVarFunc0bext = function (): boolean; stdcall;

type
  TVarFunc1bext = function (x1: cardinal): boolean; stdcall;

type
  TVarFunc2bext = function (x1, x2: cardinal): boolean; stdcall;

type
  TVarFunc3bext = function (x1, x2, x3: cardinal): boolean; stdcall;

type
  TVarFunc4bext = function (x1, x2, x3, x4: cardinal): boolean; stdcall;

type
  TVarFunc5bext = function (x1, x2, x3, x4, x5: cardinal): boolean; stdcall;

type
  TVarFunc6bext = function (x1, x2, x3, x4, x5, x6: cardinal): boolean; stdcall;

type
  TVarFunc7bext = function (x1, x2, x3, x4, x5, x6, x7: cardinal): boolean; stdcall;


///////////////////


type
  langcalltype = (_proc, _func);


type
  tonevar = object
    Name:  string;
    style: tvarstyle;
    typ:   tvartyp;
    state: variant;

  end;

var
  selectedelement: string = '';

var
  selectedelementidx: integer = -1;


type
  theva = object
    style: tvarstyle;
    function ascardinal: cardinal;
    function ascardinalext: cardinal;
  public
    state:       variant;
    return_name: string;
    statepw:     cardinal;
    needgetpw:   boolean;
    statepi:     cardinal;
    needgetpi:   boolean;
    varname: string;
  end;

type
  TVarArray = array of theva;

type
  PTVarArray = ^TVarArray;


type
  TVars = array of TOneVar;

type
  TFScript = class (TObject)
    OnDebug: pdebug;
    OnError: pdebug;
    vars:    TVars;
    begins:  array of record
      line:      cardinal;
      line_orig: cardinal;
      ends:      cardinal;
    end;
    varc:         cardinal;
    currentline:  integer;
    linecount:    cardinal;
    nextline:     string;
    substate:     longint;
    return:       longint;
    return_while: array of longint;
    reg:          TDarkRegistry;
    function Run: longint;
    function preprocess: longint;
    function onefunction (line: string): tOneVar;
    function what (s: string): tvarstyle;
    procedure Debug (s: string; err: boolean);
    procedure Log (s: string; err: boolean);
    function AddVar (Name: string; style: tvarstyle; typ: tvartyp;
      state: variant): smallint;
    function GetVar (Name: string; var style: tvarstyle; var typ: tvartyp;
      var state: variant): smallint;
    function SetVar (Name: string; style: tvarstyle; typ: tvartyp;
      state: variant): smallint;
    function ChkVar (Name: string): smallint;
    function oneline (line: string): smallint;
    function onelinepreprocess (num: smallint; line: string): smallint;
    function getpureval (line: string; num: smallint; var X: TVarArray): smallint;
    function findbeginend (line: smallint): integer;
    constructor Create (Lines: TStrings);
    destructor Destroy;
  var
    langrec:    array of record
      Name: string;
      calltype: langcalltype;
      params:   array of tvarstyle;
      Result:   tvarstyle;
      point:    pointer;
    end;

  var
    extlangrec: array of record
      Name: string;
      calltype: langcalltype;
      params:   array of tvarstyle;
      Result:   tvarstyle;
      point:    pointer;
      libh:     thandle;
    end;


  var
    he_: longint;

  var
    wi_: longint;

  var
    to_: longint;

  var
    le_: longint;

  var
    indebug: boolean;

  public
    Script: TStringList;


    function registerprocedure (proc: pointer; Name: string;
      params: array of tvarstyle): boolean;
    function registerfunction (proc: pointer; Name: string;
      params: array of tvarstyle; resulttype: tvarstyle): boolean;
    function registerextprocedure (Name: string; params: array of tvarstyle;
      lib: string): boolean;
    function registerextfunction (Name: string; params: array of tvarstyle;
      resulttype: tvarstyle; lib: string): boolean;
    function findext (s: string): integer;
    function findint (s: string): integer;
    procedure FixPointers (var va: TVarArray);

  end;

function StrToWord (const S: string): cardinal;

implementation

uses mainunit, selectvar, fdcfuncs, Parser10;

var
  FPath: string = '';

function ror32 (N, R: longword): longword;
asm
    MOV EAX,N
    MOV ECX, R
    ROR EAX, CL
end;


function rol32 (N, R: longword): longword;
asm
    MOV EAX,N
    MOV ECX, R
    ROL EAX,CL
end;

function TryStrToCardinal (const S: string; out Value: cardinal): boolean;
var
  tmpInt: int64;
begin
  Result := False;
  if TryStrToInt64(S, tmpInt) then
    if not ((tmpInt < Low(cardinal)) or (tmpInt > High(cardinal))) then
      begin
      Value  := tmpInt;
      Result := True;
      Exit;
      end;
end;


function StrToWord (const S: string): cardinal;
begin
  TryStrToCardinal(S, Result);
end;


function StrToCardinalDef (const S: string; Default: cardinal): cardinal;
begin
  if not TryStrToCardinal(S, Result) then
    Result := Default;
end;


function theva.ascardinal: cardinal;
begin
  Result := 0;
  needgetpw := False;
  needgetpi := False;
  if style = _str then
    begin
    if state <> '' then
      Result := cardinal(@string(state) [1]);
    end
  else
    begin
    if style = _pword then
      begin
      Statepw := State;
      Result  := cardinal(@statepw);
      needgetpw := True;
      end
    else
    if style = _pint then
      begin
      Statepi := State;
      Result  := cardinal(@statepi);
      needgetpi := True;
      end
    else

    if style = _word then
      Result := State
    else
    if style = _int then
      Result := variants.VarAsType(State, varLongWord);
    end;

end;


function theva.ascardinalext: cardinal;
begin
  Result := 0;
  needgetpw := False;
  needgetpi := False;
  if style = _str then
    begin
    if state <> '' then
      Result := cardinal(PChar(string(state)));
    end
  else
    begin
    if style = _pword then
      begin
      Statepw := State;
      Result  := cardinal(@statepw);
      needgetpw := True;
      end
    else
    if style = _pint then
      begin
      Statepi := State;
      Result  := cardinal(@statepi);
      needgetpi := True;
      end
    else
    if style = _word then
      Result := State
    else
    if style = _int then
      Result := VarAsType(State, varLongWord);
    end;
end;


function tfscript.findint (s: string): integer;
var
  i: integer;
begin
  Result := -1;
  if High(langrec) = -1 then
    exit;

  for i := 0 to High(langrec) do
    begin
    if sametext(langrec[i].Name, s) then
      begin
      Result := i;
      break;

      end;

    end;

end;

function tfscript.findext (s: string): integer;
var
  i: integer;
begin
  Result := -1;
  if High(extlangrec) = -1 then
    exit;

  for i := 0 to High(extlangrec) do
    begin
    if sametext(extlangrec[i].Name, s) then
      begin
      Result := i;
      break;

      end;

    end;

end;


procedure CallbackInitialized (Wnd: HWND);
begin
  if FPath <> '' then
    SendMessage(Wnd, BFFM_SETSELECTION, integer(True), longint(PChar(FPath)));
end;

function BrowseForFolderCallBack (Wnd: HWND; Msg: UINT; lParam: PItemIDList;
  lpData: longint): integer stdcall;
begin
  case Msg of
    BFFM_INITIALIZED:
      CallbackInitialized(Wnd);
    end;
  Result := 0;
end;


function UserSelectedFolder (title, path: string): string;
var
  Bi:  _browseinfoa;
  idl: PItemIdList;
  Str: array[0..260 - 1] of char;
begin
  FillChar(Bi, SizeOf(Bi), 0);
  Bi.hwndOwner := 0;
  Bi.lpszTitle := PChar(title);
  Bi.lpfn := @BrowseForFolderCallBack;
  Bi.ulFlags := 0 or $0010 or $0040;
  FPath := path;
  idl := SHBrowseForFolder(Bi);
  SHGetPathFromIDList(idl, @Str[0]);
  Result := Str;
end;


function ApplyServices (s: string; st: integer): boolean;
var
  r: TDarkRegistry;
begin
  Result := False;
  r := TDarkRegistry.Create;
  r.RootKey := HKey_Local_Machine;
  if r.KeyExists('SYSTEM\CurrentControlSet\Services\' + s) then
    begin
    r.OpenKey('SYSTEM\CurrentControlSet\Services\' + s);
    r.WriteInteger('start', st);
    r.CloseKey;
    Result := True;
    end;
  r.Free;
end;

function GetServices (s: string): integer;
var
  r: TDarkRegistry;

begin
  Result := -1;
  r := TDarkRegistry.Create;
  r.RootKey := HKey_Local_Machine;
  if r.KeyExists('SYSTEM\CurrentControlSet\Services\' + s) then
    begin
    r.OpenKey('SYSTEM\CurrentControlSet\Services\' + s);
    if r.ValueExists('start') then
      Result := r.ReadInteger('start');
    r.CloseKey;
    end;
  r.Free;
end;


function Pos (substr, str: string): integer;
begin
  Result := ansipos(UpperCase(substr), UpperCase(str));
end;

function PosEx (substr, str: string; off: integer): integer;
begin
  Delete(str, 1, off - 1);
  Result := ansipos(UpperCase(substr), UpperCase(str));
  if Result <> 0 then
    Result := Result + off - 1;
end;


function TFScript.findbeginend (line: smallint): integer;
var
  i: integer;
begin
  Result := -1;
  if (length(begins) = 0) then
    begin
    exit;
    end;
  for i := 0 to high(begins) do
    begin
    if begins[i].line = line then
      begin
      Result := begins[i].ends;
      break;
      end;
    end;
end;

function TFScript.preprocess;
var
  i: integer;
  bc, ec: integer;
  bh, eh: TStringList;

  procedure lastbegin (idx: integer);
  var
    n: integer;
    line: string;
  begin

    for n := 0 to Script.Count - 1 do

      begin

      line := AnsiLowerCase(Trim(Script[n]));

      if (pos(' begin', line) > 0) and (bh.IndexOf(IntToStr(n)) = -1) then
        begin
        begins[idx].line := n;
        begins[idx].line_orig := n;
        end
      else
      if (line = 'begin') and (bh.IndexOf(IntToStr(n)) = -1) then
        begin
        begins[idx].line := n - 1;
        begins[idx].line_orig := n;

        end
      else
      if (line = 'end') and (eh.IndexOf(IntToStr(n)) = -1) then
        begin
        begins[idx].ends := n;
        eh.Add(IntToStr(n));
        bh.Add(IntToStr(begins[idx].line_orig));
        break;
        end;

      end;

  end;

begin
  Result := DVok;
  for i := 0 to Script.Count - 1 do
    begin
    if onelinepreprocess(i, script[i]) = dverror then
      begin
      Log('  ' + IntToStr(i) + ' ...', True);
      Result := dverror;
      break;
      end;
    end;


  bc := 0;
  ec := 0;

  for i := 0 to Script.Count - 1 do
    begin
    if (pos('begin', script[i]) > 0) then
      Inc(bc)
    else
    if lowercase(script[i]) = 'end' then
      Inc(ec);
    end;

  if bc <> ec then
    begin
    Log('   begin ... end,    .', True);
    Result := DvError;
    currentline := script.Count + 1;
    exit;
    end;

  setlength(begins, 0);
  bh := TStringList.Create;
  eh := TStringList.Create;

  for i := 0 to bc - 1 do
    begin
    setlength(begins, i + 1);
    lastbegin(i);
    end;


  bh.Free;
  eh.Free;

end;

function TFScript.onelinepreprocess;
var
  Name: string;
begin
  Result := DVok;
  line := trim(line);

  if pos('label ', line) > 0 then
    begin
    Delete(line, 1, pos(line, 'label ') + 5);
    Name := trim(line);
    addvar(Name, _int, _var, num + 1);
    end;

end;

function TFScript.what;
var
  i: integer;
begin
  Result := _err;
  if s = '' then
    begin
    exit;
    end;
  s := uppercase(s);
  if (s[1] = '''') and (s[length(s)] = '''') then
    begin
    Result := _str;
    exit;
    end;
  if (s = 'TRUE') or (s = 'FALSE') then
    begin
    Result := _bool;
    exit;
    end;
  if (length(s) > 1) then
    if s[1] = '-' then
      Delete(s, 1, 1);
  for i := 1 to length(s) do
    begin
    if not (s[i] in ['0'..'9']) then
      begin
      Result := _err;
      exit;
      end;
    end;
  if pos('-', s) > 0 then
    Result := _int
  else
    Result := _word;
end;

procedure TFscript.Debug;
begin
  if ondebug <> nil then
    begin
    Tdebug(ondebug)(s, err);
    end;
end;

procedure TFscript.Log;
begin
  if onerror <> nil then
    begin
    TDebug(onerror)(s, err);
    end;
end;


function TFScript.getpureval;
var
  basestrings: array of string;
  i, vn: integer;
  ins: boolean;
  inf: integer;
  s:  string;
  c:  char;
  dummy: tvartyp;
  va: TOneVar;
begin
  Result := DVok;
  if num = 0 then
    exit;
  SetLength(X, 256);
  SetLength(BaseStrings, 256);
  //   if num > 1 then
    begin
    ///   
    ins := False;
    inf := 0;
    vn := 0;
    s := '';
    for i := 1 to length(line) do
      begin
      c := line[i];
      case c of
        '(':
          begin
          if not ins then
            begin
            Inc(inf);
            end;
          s := s + c;
          end;
        ')':
          begin
          if not ins then
            begin
            Dec(inf);
            end;
          s := s + c;
          end;

        '''':
          begin
          ins := not ins;
          s := s + c;
          end;
        ',':
          begin
          if (ins) or (inf > 0) then
            begin
            s := s + c;
            end
          else
            begin
            basestrings[vn] := trim(s);
            s := '';
            Inc(vn);
            end;
          end;
        else
          begin
          s := s + c;
          end;
        end;

      end;
    if s <> '' then
      begin
      basestrings[vn] := Trim(s);
      Inc(vn);
      end;

    end;

  if vn < num then
    begin
    log('     ', True);
    Result := dverror;
    end;

  for i := 0 to vn - 1 do
    begin
    if chkvar(basestrings[i]) = dvok then
      begin
      x[i].varname := basestrings[i];
      GetVar(basestrings[i], x[i].style, dummy, x[i].state);
      if x[i].style = _pword then
        x[i].return_name := basestrings[i]
      else
      if x[i].style = _pint then
        x[i].return_name := basestrings[i];
      end
    else
      begin

      case
        what(basestrings[i]) of
        _str:
          begin
          x[i].state := copy(basestrings[i], 2, length(basestrings[i]) - 2);
          x[i].style := _str;
          if indebug then
            fdcmain.Memo.Lines.Append(Format('''%s'' --> string', [basestrings[i]]));
          end;

        _int:
          begin
          x[i].state := (StrToIntDef(basestrings[i], -1));
          x[i].style := _int;
          if indebug then
            fdcmain.Memo.Lines.Append(Format('''%s'' --> integer', [basestrings[i]]));
          end;

        _word:
          begin
          x[i].state := (StrToCardinalDef(basestrings[i], 0));
          x[i].style := _word;
          if indebug then
            fdcmain.Memo.Lines.Append(Format('''%s'' --> word', [basestrings[i]]));
          end;

        _pword:
          begin
          x[i].state := (StrToCardinalDef(basestrings[i], 0));
          x[i].style := _pword;
          if indebug then
            fdcmain.Memo.Lines.Append(Format('''%s'' --> pword', [basestrings[i]]));
          end;

        _pint:
          begin
          x[i].state := (StrToIntDef(basestrings[i], -1));
          x[i].style := _pint;
          if indebug then
            fdcmain.Memo.Lines.Append(Format('''%s'' --> pint', [basestrings[i]]));
          end;


        _bool:
          begin
          x[i].state := StrToBoolDef(basestrings[i], False);
          x[i].style := _bool;
          if indebug then
            fdcmain.Memo.Lines.Append(Format('''%s'' --> boolean', [basestrings[i]]));
          end;


        else
          begin
          va := onefunction(basestrings[i]);

          if va.Name <> '' then
            begin
            x[i].style := va.style;
            x[i].varname:=va.Name;


            case va.style of
              _pint:
                x[i].state := VarAsType(va.state, varInteger);
              _pword:
                x[i].state := VarAsType(va.state, varLongWord);
              _word:
                x[i].state := VarAsType(va.state, varLongWord);
              _int:
                x[i].state := VarAsType(va.state, varInteger);
              _str:
                x[i].state := VarAsType(va.state, varString);
              _bool:
                x[i].state := VarAsType(va.state, varBoolean);
              _err:
                x[i].state := (va.state);
              end;


            if indebug then
              begin

              end;
            end
          else
            begin
            Result := dverror;
            log(' : ' + '''' + basestrings[i] +
              '''' + '  ' + IntToStr(currentline) + ': ''' + line + '''', True);
            end;
          end;
        end;
      end;
    end;
end;

function TFScript.GetVar;
var
  i: integer;
begin
  Name := UpperCase(Name);
  Result := dverror;
  if varc = 0 then
    begin
    exit;
    end;
  for i := 0 to varc - 1 do
    begin
    if vars[i].Name = Name then
      begin
      style := vars[i].style;
      typ := vars[i].typ;
      case style of
        _pint:
          state := VarAsType(vars[i].state, varInteger);
        _pword:
          state := VarAsType(vars[i].state, varLongWord);
        _word:
          state := VarAsType(vars[i].state, varLongWord);
        _int:
          state := VarAsType(vars[i].state, varInteger);
        _str:
          state := VarAsType(vars[i].state, varString);
        _bool:
          state := VarAsType(vars[i].state, varBoolean);
        _err:
          state := (vars[i].state);
        end;


      Result := dvok;
      break;
      end;
    end;
end;


function TFScript.SetVar;
var
  i: integer;
begin
  Name := UpperCase(Name);
  Result := dverror;
  if varc = 0 then
    begin
    exit;
    end;
  for i := 0 to varc - 1 do
    begin
    if vars[i].Name = Name then
      begin
      vars[i].style := style;
      vars[i].typ := typ;
      case style of
        _pint:
          vars[i].state := VarAsType(state, varInteger);
        _pword:
          vars[i].state := VarAsType(state, varLongWord);
        _word:
          vars[i].state := VarAsType(state, varLongWord);
        _int:
          vars[i].state := VarAsType(state, varInteger);
        _str:
          vars[i].state := VarAsType(state, varString);
        _bool:
          vars[i].state := VarAsType(state, varBoolean);
        _err:
          vars[i].state := (state);
        end;

      Result := dvok;
      break;
      end;
    end;
end;


function TFScript.ChkVar;
var
  i: integer;
begin
  Name := UpperCase(Name);
  Result := dverror;
  if varc = 0 then
    begin
    exit;
    end;
  for i := 0 to varc - 1 do
    begin
    if vars[i].Name = Name then
      begin
      Result := dvok;
      break;
      end;
    end;
end;


function TFScript.AddVar;
begin
  Name := UpperCase(Name);
  Result := dverror;
  if chkvar(Name) = dvok then
    begin
    exit;
    end;
  Inc(varc);
  setlength(vars, varc);
  vars[varc - 1].Name := Name;
  vars[varc - 1].style := style;
  vars[varc - 1].typ := typ;

  case style of
    _pint:
      vars[varc - 1].state := VarAsType(state, varInteger);
    _pword:
      vars[varc - 1].state := VarAsType(state, varLongWord);
    _word:
      vars[varc - 1].state := VarAsType(state, varLongWord);
    _int:
      vars[varc - 1].state := VarAsType(state, varInteger);
    _str:
      vars[varc - 1].state := VarAsType(state, varString);
    _bool:
      vars[varc - 1].state := VarAsType(state, varBoolean);
    _err:
      vars[varc - 1].state := state;
    end;


  Result := dvok;
end;

function TFScript.onefunction;
var
  Name, s: string;
  i, f, n: integer;
  extpar: array of tvarstyle;
  rt: Tvarstyle;
  od: TOpenDialog;
  pa: ansistring;
  EX: TStrings;

  buff: longint;

var
  va: TVarArray;
  allowdir: boolean;
  vs: TVarStyle;
  vt: TVarTyp;
  varv: variant;
  express: string;
  EP: TCustomParser;

  ///////////!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! XXXXXXXXXXXXXXX
  function OneDirectoryExNameWipe (APath: string): boolean;
  var
    SR: TSearchRec;
    ignored: boolean;
  begin
    ignored := False;
    if findfirst(APath + '\*.*', faReadOnly + faHidden + faSysFile +
      faArchive + faDirectory, SR) = 0 then
      repeat
        if (SR.Attr and faDirectory <> 0) then
          begin
          if (sr.Name <> '..') and (sr.Name <> '.') then
            ignored := not OneDirectoryExNameWipe(Apath + '\' + SR.Name);
          end
        else
        if ex.IndexOf(sr.Name) = -1 then
          begin
          if not wipefile(PChar(apath + '\' + sr.Name)) then
            begin
            ignored := True;
            log('  ' + sr.Name + '!', True);
            end
          else
            log(': ' + sr.Name, False);

          end
        else
          ignored := True;
      until findnext(SR) <> 0;
    SysUtils.FindClose(sr);
    if ((not ignored) and directoryexists(apath) and (not isinexcl(apath)) and
      (allowdir)) then
      begin
      if removedir(PChar(apath)) then
        log(' : ' + apath, False)
      else
        log('   : ' + apath + '!', True);
      end;
    Result := not ignored;
  end;

  function OneDirectoryAllWipe (APath: string): boolean;
  var
    SR: TSearchRec;
    ignored: boolean;
  begin
    ignored := False;
    if findfirst(APath + '\*.*', faReadOnly + faHidden + faSysFile +
      faArchive + faDirectory, SR) = 0 then
      repeat
        if (SR.Attr and faDirectory <> 0) then
          begin
          if (sr.Name <> '..') and (sr.Name <> '.') then
            ignored := not OneDirectoryAllWipe(Apath + '\' + SR.Name);
          end
        else
        if not wipefile(PChar(apath + '\' + sr.Name)) then
          begin
          ignored := True;
          log('  : ' + sr.Name + '!', True);
          end
        else
          log(': ' + sr.Name, False);


      until findnext(SR) <> 0;
    SysUtils.FindClose(sr);
    if (not ignored) and directoryexists(apath) and
      (not isinexcl(apath) and (allowdir)) then
      begin
      if removedir(PChar(apath)) then
        log(' : ' + apath, False)
      else
        log('   : ' + apath + '!', False);
      end;
    Result := not ignored;
  end;

  function OneDirectoryByExtWipe (APath: string): boolean;
  var
    SR: TSearchRec;
    ignored: boolean;
  begin
    ignored := False;
    if findfirst(APath + '\*.*', faReadOnly + faHidden + faSysFile +
      faArchive + faDirectory, SR) = 0 then
      repeat
        if (SR.Attr and faDirectory <> 0) then
          begin
          if (sr.Name <> '..') and (sr.Name <> '.') then
            ignored := not OneDirectoryByExtWipe(Apath + '\' + SR.Name);
          end
        else
        if (ExtractFileExt(sr.Name) <> '') and
          (ex.IndexOf(ExtractFileExt(sr.Name)) <> -1) then
          begin

          if not wipefile(PChar(apath + '\' + sr.Name)) then
            begin
            ignored := True;
            log('  : ' + sr.Name + '!', True);
            end
          else
            log(': ' + sr.Name, False);

          end
        else
          ignored := True;

      until findnext(SR) <> 0;
    SysUtils.FindClose(sr);
    if (not ignored) and directoryexists(apath) and
      (not isinexcl(apath) and (allowdir)) then
      begin
      if removedir(PChar(apath)) then
        log(' : ' + apath, False)
      else
        log('   : ' + apath + '!', True);
      end;
    Result := not ignored;
  end;


  function OneDirectoryByExtNRWipe (APath: string): boolean;
  var
    SR: TSearchRec;
    ignored: boolean;
  begin
    ignored := False;
    if findfirst(APath + '\*.*', faReadOnly + faHidden + faSysFile +
      faArchive + faDirectory, SR) = 0 then
      repeat
        if (SR.Attr and faDirectory <> 0) then
          begin
          {------------------------------------------------------}
          end
        else
        if (ExtractFileExt(sr.Name) <> '') and
          (ex.IndexOf(ExtractFileExt(sr.Name)) <> -1) then
          begin

          if not wipefile(PChar(apath + '\' + sr.Name)) then
            begin
            ignored := True;
            log('  : ' + sr.Name + '!', True);
            end
          else
            log(': ' + sr.Name, False);

          end
        else
          ignored := True;

      until findnext(SR) <> 0;
    SysUtils.FindClose(sr);
    if (not ignored) and directoryexists(apath) and
      (not isinexcl(apath) and (allowdir)) then
      begin
      if removedir(PChar(apath)) then
        log(' : ' + apath, False)
      else
        log('   : ' + apath + '!', True);
      end;
    Result := not ignored;
  end;


  function OneDirectoryByMaskNRWipe (APath: string): boolean;
  var
    SR: TSearchRec;
    ignored: boolean;

    function checkmask (s: string): boolean;
    var
      i: integer;
    begin
      Result := False;
      for i := 0 to ex.Count - 1 do
        if srchunit.matchesmask(s, ex[i]) then
          begin
          Result := True;
          exit;
          end;
    end;

  begin
    ignored := False;
    if findfirst(APath + '\*.*', faReadOnly + faHidden + faSysFile +
      faArchive + faDirectory, SR) = 0 then
      repeat
        if (SR.Attr and faDirectory <> 0) then
          begin
          {------------------------------------------------------}
          end
        else
        if (checkmask(SR.Name)) then
          begin

          if not wipefile(PChar(apath + '\' + sr.Name)) then
            begin
            ignored := True;
            log('  : ' + sr.Name + '!', True);
            end
          else
            log(': ' + sr.Name, False);

          end
        else
          ignored := True;

      until findnext(SR) <> 0;
    SysUtils.FindClose(sr);
    if (not ignored) and directoryexists(apath) and
      (not isinexcl(apath) and (allowdir)) then
      begin
      if removedir(PChar(apath)) then
        log(' : ' + apath, False)
      else
        log('   : ' + apath + '!', True);
      end;
    Result := not ignored;
  end;

  function OneDirectoryAgeWipe (APath, Ext: string; age: integer): boolean;
  var
    SR: TSearchRec;
    ignored: boolean;
    n:  TDateTime;
  begin
    ignored := False;
    n := now;
    if findfirst(APath + '\*.*', faReadOnly + faHidden + faSysFile +
      faArchive + faDirectory, SR) = 0 then
      repeat
        if (SR.Attr and faDirectory <> 0) then
          begin
          if (sr.Name <> '..') and (sr.Name <> '.') then
            ignored := not OneDirectoryAgeWipe(Apath + '\' + SR.Name, Ext, Age);
          end
        else
        if SameText(ExtractFileExt(sr.Name), Ext) then
          if DaysBetween(FileDateToDateTime(sr.Time), n) >= age then

            begin
            if not wipefile(PChar(apath + '\' + sr.Name)) then
              begin
              ignored := True;
              log('  : ' + sr.Name + '!', True);
              end
            else
              log(': ' + sr.Name, False);

            end
          else
            ignored := True;
      until findnext(SR) <> 0;
    SysUtils.FindClose(sr);
    if (not ignored) and directoryexists(apath) and
      (not isinexcl(apath) and (allowdir)) then
      begin
      if removedir(PChar(apath)) then
        log(' : ' + apath, False)
      else
        log('   : ' + apath + '!', True);
      end;
    Result := not ignored;
  end;


  function OneDirectoryOnlyFWipe (APath: string): boolean;
  var
    SR: TSearchRec;
    ignored: boolean;
  begin
    ignored := False;
    if findfirst(APath + '\*.*', faReadOnly + faHidden + faSysFile +
      faArchive + faDirectory, SR) = 0 then
      repeat
        if (SR.Attr and faDirectory <> 0) then
          begin
          if (sr.Name <> '..') and (sr.Name <> '.') then
            ignored := not OneDirectoryOnlyFWipe(Apath + '\' + SR.Name);
          end
        else
        if ex.IndexOf(sr.Name) <> -1 then
          begin
          if not wipefile(PChar(apath + '\' + sr.Name)) then
            begin
            ignored := True;
            log('  : ' + sr.Name + '!', True);
            end
          else
            log(': ' + sr.Name, False);

          end
        else
          ignored := True;
      until findnext(SR) <> 0;
    SysUtils.FindClose(sr);
    if (not ignored) and directoryexists(apath) and
      (not isinexcl(apath) and (allowdir)) then
      begin
      if removedir(PChar(apath)) then
        log(' : ' + apath, False)
      else
        log('   : ' + apath + '!', True);
      end;
    Result := not ignored;
  end;

  function OneDirectoryOnlyFNRWipe (APath: string): boolean;
  var
    SR: TSearchRec;
    ignored: boolean;
  begin
    ignored := False;
    if findfirst(APath + '\*.*', faReadOnly + faHidden + faSysFile +
      faArchive + faDirectory, SR) = 0 then
      repeat
        if (SR.Attr and faDirectory <> 0) then
          begin
          if (sr.Name <> '..') and (sr.Name <> '.') then
            ignored := True;
          end
        else
        if ex.IndexOf(sr.Name) <> -1 then
          begin
          if not wipefile(PChar(apath + '\' + sr.Name)) then
            begin
            ignored := True;
            log('  : ' + sr.Name + '!', True);
            end
          else
            log(': ' + sr.Name, False);

          end
        else
          ignored := True;
      until findnext(SR) <> 0;
    SysUtils.FindClose(sr);
    if (not ignored) and directoryexists(apath) and
      (not isinexcl(apath) and (allowdir)) then
      begin
      if removedir(PChar(apath)) then
        log(' : ' + apath, False)
      else
        log('   : ' + apath + '!', True);
      end;
    Result := not ignored;
  end;


  //////////!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


  ///////////////////////////////////////////////////////////////////////////////////////////

  function OneDirectoryExName (APath: string): boolean;
  var
    SR: TSearchRec;
    ignored: boolean;
  begin
    ignored := False;
    if findfirst(APath + '\*.*', faReadOnly + faHidden + faSysFile +
      faArchive + faDirectory, SR) = 0 then
      repeat
        if (SR.Attr and faDirectory <> 0) then
          begin
          if (sr.Name <> '..') and (sr.Name <> '.') then
            ignored := not OneDirectoryExName(Apath + '\' + SR.Name);
          end
        else
        if ex.IndexOf(sr.Name) = -1 then
          begin
          if not deletefile(PChar(apath + '\' + sr.Name)) then
            begin
            ignored := True;
            log('  ' + sr.Name + '!', True);
            end
          else
            log(': ' + sr.Name, False);

          end
        else
          ignored := True;
      until findnext(SR) <> 0;
    SysUtils.FindClose(sr);
    if ((not ignored) and directoryexists(apath) and (not isinexcl(apath)) and
      (allowdir)) then
      begin
      if removedir(PChar(apath)) then
        log(' : ' + apath, False)
      else
        log('   : ' + apath + '!', True);
      end;
    Result := not ignored;
  end;

  function OneDirectoryAll (APath: string): boolean;
  var
    SR: TSearchRec;
    ignored: boolean;
  begin
    ignored := False;
    if findfirst(APath + '\*.*', faReadOnly + faHidden + faSysFile +
      faArchive + faDirectory, SR) = 0 then
      repeat
        if (SR.Attr and faDirectory <> 0) then
          begin
          if (sr.Name <> '..') and (sr.Name <> '.') then
            ignored := not OneDirectoryAll(Apath + '\' + SR.Name);
          end
        else
        if not deletefile(PChar(apath + '\' + sr.Name)) then
          begin
          ignored := True;
          log('  : ' + sr.Name + '!', True);
          end
        else
          log(': ' + sr.Name, False);


      until findnext(SR) <> 0;
    SysUtils.FindClose(sr);
    if (not ignored) and directoryexists(apath) and
      (not isinexcl(apath) and (allowdir)) then
      begin
      if removedir(PChar(apath)) then
        log(' : ' + apath, False)
      else
        log('   : ' + apath + '!', False);
      end;
    Result := not ignored;
  end;

  function OneDirectoryByExt (APath: string): boolean;
  var
    SR: TSearchRec;
    ignored: boolean;
  begin
    ignored := False;
    if findfirst(APath + '\*.*', faReadOnly + faHidden + faSysFile +
      faArchive + faDirectory, SR) = 0 then
      repeat
        if (SR.Attr and faDirectory <> 0) then
          begin
          if (sr.Name <> '..') and (sr.Name <> '.') then
            ignored := not OneDirectoryByExt(Apath + '\' + SR.Name);
          end
        else
        if (ExtractFileExt(sr.Name) <> '') and
          (ex.IndexOf(ExtractFileExt(sr.Name)) <> -1) then
          begin

          if not deletefile(PChar(apath + '\' + sr.Name)) then
            begin
            ignored := True;
            log('  : ' + sr.Name + '!', True);
            end
          else
            log(': ' + sr.Name, False);

          end
        else
          ignored := True;

      until findnext(SR) <> 0;
    SysUtils.FindClose(sr);
    if (not ignored) and directoryexists(apath) and
      (not isinexcl(apath) and (allowdir)) then
      begin
      if removedir(PChar(apath)) then
        log(' : ' + apath, False)
      else
        log('   : ' + apath + '!', True);
      end;
    Result := not ignored;
  end;


  function OneDirectoryByExtNR (APath: string): boolean;
  var
    SR: TSearchRec;
    ignored: boolean;
  begin
    ignored := False;
    if findfirst(APath + '\*.*', faReadOnly + faHidden + faSysFile +
      faArchive + faDirectory, SR) = 0 then
      repeat
        if (SR.Attr and faDirectory <> 0) then
          begin
          {------------------------------------------------------}
          end
        else
        if (ExtractFileExt(sr.Name) <> '') and
          (ex.IndexOf(ExtractFileExt(sr.Name)) <> -1) then
          begin

          if not deletefile(PChar(apath + '\' + sr.Name)) then
            begin
            ignored := True;
            log('  : ' + sr.Name + '!', True);
            end
          else
            log(': ' + sr.Name, False);

          end
        else
          ignored := True;

      until findnext(SR) <> 0;
    SysUtils.FindClose(sr);
    if (not ignored) and directoryexists(apath) and
      (not isinexcl(apath) and (allowdir)) then
      begin
      if removedir(PChar(apath)) then
        log(' : ' + apath, False)
      else
        log('   : ' + apath + '!', True);
      end;
    Result := not ignored;
  end;


  function OneDirectoryByMaskNR (APath: string): boolean;
  var
    SR: TSearchRec;
    ignored: boolean;

    function checkmask (s: string): boolean;
    var
      i: integer;
    begin
      Result := False;
      for i := 0 to ex.Count - 1 do
        if srchunit.matchesmask(s, ex[i]) then
          begin
          Result := True;
          exit;
          end;
    end;

  begin
    ignored := False;
    if findfirst(APath + '\*.*', faReadOnly + faHidden + faSysFile +
      faArchive + faDirectory, SR) = 0 then
      repeat
        if (SR.Attr and faDirectory <> 0) then
          begin
          {------------------------------------------------------}
          end
        else
        if (checkmask(SR.Name)) then
          begin

          if not deletefile(PChar(apath + '\' + sr.Name)) then
            begin
            ignored := True;
            log('  : ' + sr.Name + '!', True);
            end
          else
            log(': ' + sr.Name, False);

          end
        else
          ignored := True;

      until findnext(SR) <> 0;
    SysUtils.FindClose(sr);
    if (not ignored) and directoryexists(apath) and
      (not isinexcl(apath) and (allowdir)) then
      begin
      if removedir(PChar(apath)) then
        log(' : ' + apath, False)
      else
        log('   : ' + apath + '!', True);
      end;
    Result := not ignored;
  end;

  function OneDirectoryAge (APath, Ext: string; age: integer): boolean;
  var
    SR: TSearchRec;
    ignored: boolean;
    n:  TDateTime;
  begin
    ignored := False;
    n := now;
    if findfirst(APath + '\*.*', faReadOnly + faHidden + faSysFile +
      faArchive + faDirectory, SR) = 0 then
      repeat
        if (SR.Attr and faDirectory <> 0) then
          begin
          if (sr.Name <> '..') and (sr.Name <> '.') then
            ignored := not OneDirectoryAge(Apath + '\' + SR.Name, Ext, Age);
          end
        else
        if SameText(ExtractFileExt(sr.Name), Ext) then
          if DaysBetween(FileDateToDateTime(sr.Time), n) >= age then

            begin
            if not deletefile(PChar(apath + '\' + sr.Name)) then
              begin
              ignored := True;
              log('  : ' + sr.Name + '!', True);
              end
            else
              log(': ' + sr.Name, False);

            end
          else
            ignored := True;
      until findnext(SR) <> 0;
    SysUtils.FindClose(sr);
    if (not ignored) and directoryexists(apath) and
      (not isinexcl(apath) and (allowdir)) then
      begin
      if removedir(PChar(apath)) then
        log(' : ' + apath, False)
      else
        log('   : ' + apath + '!', True);
      end;
    Result := not ignored;
  end;


  function OneDirectoryOnlyF (APath: string): boolean;
  var
    SR: TSearchRec;
    ignored: boolean;
  begin
    ignored := False;
    if findfirst(APath + '\*.*', faReadOnly + faHidden + faSysFile +
      faArchive + faDirectory, SR) = 0 then
      repeat
        if (SR.Attr and faDirectory <> 0) then
          begin
          if (sr.Name <> '..') and (sr.Name <> '.') then
            ignored := not OneDirectoryOnlyF(Apath + '\' + SR.Name);
          end
        else
        if ex.IndexOf(sr.Name) <> -1 then
          begin
          if not deletefile(PChar(apath + '\' + sr.Name)) then
            begin
            ignored := True;
            log('  : ' + sr.Name + '!', True);
            end
          else
            log(': ' + sr.Name, False);

          end
        else
          ignored := True;
      until findnext(SR) <> 0;
    SysUtils.FindClose(sr);
    if (not ignored) and directoryexists(apath) and
      (not isinexcl(apath) and (allowdir)) then
      begin
      if removedir(PChar(apath)) then
        log(' : ' + apath, False)
      else
        log('   : ' + apath + '!', True);
      end;
    Result := not ignored;
  end;

  function OneDirectoryOnlyFNR (APath: string): boolean;
  var
    SR: TSearchRec;
    ignored: boolean;
  begin
    ignored := False;
    if findfirst(APath + '\*.*', faReadOnly + faHidden + faSysFile +
      faArchive + faDirectory, SR) = 0 then
      repeat
        if (SR.Attr and faDirectory <> 0) then
          begin
          if (sr.Name <> '..') and (sr.Name <> '.') then
            ignored := True;
          end
        else
        if ex.IndexOf(sr.Name) <> -1 then
          begin
          if not deletefile(PChar(apath + '\' + sr.Name)) then
            begin
            ignored := True;
            log('  : ' + sr.Name + '!', True);
            end
          else
            log(': ' + sr.Name, False);

          end
        else
          ignored := True;
      until findnext(SR) <> 0;
    SysUtils.FindClose(sr);
    if (not ignored) and directoryexists(apath) and
      (not isinexcl(apath) and (allowdir)) then
      begin
      if removedir(PChar(apath)) then
        log(' : ' + apath, False)
      else
        log('   : ' + apath + '!', True);
      end;
    Result := not ignored;
  end;

  ///////////////////////////////////////////////////////////////////////////////////////////

begin
  allowdir := False;
  if chkvar('canremovedirectories') = dvOk then
    begin
    GetVar('canremovedirectories', vs, vt, varv);
    allowdir := varv;
    end;
  if chkvar('autoexit') = dvOk then
    begin
    GetVar('autoexit', vs, vt, varv);
    wantexit := varv;
    end;
  line := trim(line);
  Name := copy(line, 1, pos('(', line) - 1);
  Delete(line, 1, length(Name));
  Name := trim(Name);
  line := trim(line);
  Delete(line, pos('(', line), 1);
  Delete(line, length(line), 1);
  Name := lowercase(Name);

  if Name = 'copyfile' then
    begin
    Result.Name := Name;
    Result.style := _bool;
    Result.typ := _var;
    if getpureval(line, 2, va) <> dvok then
      begin
      log('      ' + Result.Name, True);
      Return := DVError;
      exit;
      end;

    Result.state := boolean(Windows.CopyFile(PChar(string(va[0].state)),
      PChar(string(va[1].state)), False));
    end
  else
    begin
    if Name = 'deletefile' then
      begin
      Result.Name := Name;
      Result.style := _bool;
      Result.typ := _var;
      if getpureval(line, 1, va) <> dvok then
        begin
        log('      ' + Result.Name, True);
        Return := DVError;
        exit;
        end;

      Result.state := boolean(Windows.DeleteFile(PChar(string(va[0].state))));
      end
    else
    if Name = 'deletefilewipe' then
      begin
      Result.Name := Name;
      Result.style := _bool;
      Result.typ := _var;
      if getpureval(line, 1, va) <> dvok then
        begin
        log('      ' + Result.Name, True);
        Return := DVError;
        exit;
        end;

      Result.state := boolean(WipeFile(PChar(string(va[0].state))));
      end


    else
    if Name = 'open' then
      begin
      Result.Name := Name;
      Result.style := _int;
      Result.typ := _var;
      if getpureval(line, 1, va) <> dvok then
        begin
        log('      ' + Result.Name, True);
        Return := DVError;
        exit;
        end;

      Result.state := sysutils.FileOpen(va[0].state, fmOpenReadWrite);
      end


    else
    if Name = 'create' then
      begin
      Result.Name := Name;
      Result.style := _int;
      Result.typ := _var;
      if getpureval(line, 1, va) <> dvok then
        begin
        log('      ' + Result.Name, True);
        Return := DVError;
        exit;
        end;

      Result.state := sysutils.FileCreate(va[0].state);
      end

    else
    if Name = 'close' then
      begin
      Result.Name := Name;
      Result.style := _bool;
      Result.typ := _var;
      if getpureval(line, 1, va) <> dvok then
        begin
        log('      ' + Result.Name, True);
        Return := DVError;
        exit;
        end;

      sysutils.FileClose(va[0].state);
      Result.state := true;
      end


    else
    if Name = 'fwrite' then
      begin
      Result.Name := Name;
      Result.style := _int;
      Result.typ := _var;
      if getpureval(line, 2, va) <> dvok then
        begin
        log('      ' + Result.Name, True);
        Return := DVError;
        exit;
        end;

      buff := va[1].state;

      Result.state := sysutils.FileWrite(va[0].state, buff, 4);
      end

    else
    if Name = 'fread' then
      begin
      Result.Name := Name;
      Result.style := _int;
      Result.typ := _var;
      if getpureval(line, 2, va) <> dvok then
        begin
        log('      ' + Result.Name, True);
        Return := DVError;
        exit;
        end;


      Result.state := sysutils.FileRead(va[0].state, buff, 4);

      SetVar(va[1].return_name, _pint, _var, buff);

      end


    else
    if Name = 'fseek' then
      begin
      Result.Name := Name;
      Result.style := _bool;
      Result.typ := _var;
      if getpureval(line, 2, va) <> dvok then
        begin
        log('      ' + Result.Name, True);
        Return := DVError;
        exit;
        end;

      Sysutils.FileSeek(va[0].state, va[1].state, 0);


      Result.state := true;

      end


    else
    if Name = 'ftrunc' then
      begin
      Result.Name := Name;
      Result.style := _bool;
      Result.typ := _var;
      if getpureval(line, 1, va) <> dvok then
        begin
        log('      ' + Result.Name, True);
        Return := DVError;
        exit;
        end;

SetEndOfFile(THandle(va[0].state));


      Result.state := true;

      end
      


    else

      begin
      if Name = 'fileexists' then
        begin
        Result.Name := Name;
        Result.style := _bool;
        Result.typ := _var;
        if getpureval(line, 1, va) <> dvok then
          begin
          log('      ' + Result.Name, True);
          Return := DVError;
          exit;
          end;

        Result.state := boolean(SysUtils.FileExists((string(va[0].state))));
        end
      else
        begin
        if Name = 'extractfilename' then
          begin
          Result.Name := Name;
          Result.style := _str;
          Result.typ := _var;
          if getpureval(line, 1, va) <> dvok then
            begin
            log('      ' + Result.Name, True);
            Return := DVError;
            exit;
            end;

          Result.state := string(ExtractFileName((VarAsType(va[0].state, varString))));
          end
        else
        if Name = 'extractfilepath' then
          begin

          Result.Name := Name;
          Result.style := _str;
          Result.typ := _var;
          if getpureval(line, 1, va) <> dvok then
            begin
            log('      ' + Result.Name, True);
            Return := DVError;
            exit;
            end;

          Result.state :=
            string(ExtractFilePath((VarAsType(va[0].state, varString))));
          end
        else
        if Name = 'extractfileext' then
          begin

          Result.Name := Name;
          Result.style := _str;
          Result.typ := _var;
          if getpureval(line, 1, va) <> dvok then
            begin
            log('      ' + Result.Name, True);
            Return := DVError;
            exit;
            end;

          Result.state :=
            string(ExtractFileExt((VarAsType(va[0].state, varString))));
          end
        else
        if Name = 'extractfiledir' then
          begin
          Result.Name := Name;
          Result.style := _str;
          Result.typ := _var;
          if getpureval(line, 1, va) <> dvok then
            begin
            log('      ' + Result.Name, True);
            Return := DVError;
            exit;
            end;
          Result.state :=
            string(ExtractFileDir((VarAsType(va[0].state, varString))));
          end

        else
        if Name = 'addslash' then
          begin
          Result.Name := Name;
          Result.style := _str;
          Result.typ := _var;
          if getpureval(line, 1, va) <> dvok then
            begin
            log('      ' + Result.Name, True);
            Return := DVError;
            exit;
            end;
          Result.state :=
            string(IncludeTrailingBackslash(
            (VarAsType(va[0].state, varString))));
          end

        else
        if Name = 'cutslash' then
          begin
          Result.Name := Name;
          Result.style := _str;
          Result.typ := _var;
          if getpureval(line, 1, va) <> dvok then
            begin
            log('      ' + Result.Name, True);
            Return := DVError;
            exit;
            end;
          Result.state :=
            string(ExcludeTrailingBackslash(
            (VarAsType(va[0].state, varString))));
          end

        else
        if Name = 'changefileext' then
          begin
          Result.Name := Name;
          Result.style := _str;
          Result.typ := _var;
          if getpureval(line, 2, va) <> dvok then
            begin
            log('      ' +
              Result.Name, True);
            Return := DVError;
            exit;
            end;

          Result.state :=
            string(ChangeFileExt(VarAsType(va[0].state, varString),
            VarAsType(va[1].state, varString)));
          end
        else
        if Name = 'trim' then
          begin
          Result.Name := Name;
          Result.style := _str;
          Result.typ := _var;
          if getpureval(line, 1, va) <> dvok then
            begin
            log('      ' +
              Result.Name, True);
            Return := DVError;
            exit;
            end;

          Result.state :=
            string(Trim(VarAsType(va[0].state, varString)));
          end
        else
        if Name = 'uppercase' then
          begin
          Result.Name := Name;
          Result.style := _str;
          Result.typ := _var;
          if getpureval(line, 1, va) <> dvok then
            begin
            log('      ' +
              Result.Name, True);
            Return := DVError;
            exit;
            end;

          Result.state :=
            string(UpperCase(VarAsType(va[0].state, varString)));
          end
        else
        if Name = 'lowercase' then
          begin
          Result.Name := Name;
          Result.style := _str;
          Result.typ := _var;
          if getpureval(line, 1, va) <> dvok then
            begin
            log('      ' +
              Result.Name, True);
            Return := DVError;
            exit;
            end;

          Result.state :=
            string(LowerCase(VarAsType(va[0].state, varString)));
          end
        else
        if Name = 'writeln' then
          begin
          Result.Name := Name;
          Result.style := _bool;
          Result.typ := _var;
          if getpureval(line, 1, va) <> dvok then
            begin
            log('      ' +
              Result.Name, True);
            Return := DVError;
            exit;
            end;

          Result.state := True;
          if va[0].style in
            [_pint, _pword, _word, _int, _bool, _str] then
            log(va[0].state, False)
          else
            begin
            log('    !', True);
            Result.state := False;
            end;
          end
        else
        if Name = 'ask' then
          begin
          Result.Name := Name;
          Result.style := _bool;
          Result.typ := _var;
          if getpureval(line, 1, va) <> dvok then
            begin
            log('      ' +
              Result.Name, True);
            Return := DVError;
            exit;
            end;
          Result.state :=
            boolean(MessageDlg(
            VarAsType(va[0].state, varString), mtConfirmation,
            [mbYes, mbNo], 0) = idYes);
          end

        else
        if Name = 'say' then
          begin
          Result.Name := Name;
          Result.style := _bool;
          Result.typ := _var;
          if getpureval(line, 1, va) <> dvok then
            begin
            log('      ' +
              Result.Name, True);
            Return := DVError;
            exit;
            end;
          Result.state := True;
          MessageDlg(VarAsType(va[0].state, varString),
            mtInformation, [mbOK], 0);
          end
        ///////////
        else
        if Name = 'exec' then
          begin
          Result.Name := Name;
          Result.style := _bool;
          Result.typ := _var;
          if getpureval(line, 1, va) <> dvok then
            begin
            log('      ' +
              Result.Name, True);
            Return := DVError;
            exit;
            end;
          Result.state := True;
          winexec(
            PChar(string(VarAsType(va[0].state, varString))), sw_show);
          end
        ///////////
        ///////////
        else
        if Name = 'execandwait' then
          begin
          Result.Name := Name;
          Result.style := _bool;
          Result.typ := _var;
          if getpureval(line, 1, va) <> dvok then
            begin
            log('      ' +
              Result.Name, True);
            Return := DVError;
            exit;
            end;
          Result.state := True;
          runandwait(VarAsType(va[0].state, varString));
          end
        ///////////
        else
        if Name = 'selectelement' then
          begin
          selectedelement := '';
          Result.Name := Name;
          Result.style := _str;
          Result.typ := _var;
          if getpureval(line, 2, va) <> dvok then
            begin
            log('      ' +
              Result.Name, True);
            Return := DVError;
            exit;
            end;
          application.CreateForm(
            TSelectElement, SelectElement);
          for i :=
            3 to VarAsType(va[2].state, varInteger) + 2 do
            selectelement.element.Items.Append(
              VarAsType(va[i].state, varString));
          selectelement.Caption :=
            VarAsType(va[0].state, varString);
          selectelement.Memo.Text :=
            VarAsType(va[1].state, varString);
          selectelement.showmodal;
          selectelement.Free;
          Result.state := selectedelement;
          end
        else
        if Name = 'selectfile' then
          begin
          Result.Name := Name;
          Result.style := _str;
          Result.state := '';
          Result.typ := _var;
          if getpureval(line, 2, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return := DVError;
            exit;
            end;
          od := TOpenDialog.Create(nil);
          od.Title := va[0].state;
          od.Filter := va[1].state;
          if od.Execute then
            Result.state := od.FileName;
          end

        else
        if Name = 'selectdirectory' then
          begin
          Result.Name := Name;
          Result.style := _str;
          Result.typ := _var;
          if getpureval(line, 2, va) <> dvok then
            begin
            log('      '
              + Result.Name, True);
            Return := DVError;
            exit;
            end;
          Result.state :=
            userselectedfolder(VarAsType(va[0].state, varString),
            VarAsType(va[1].state, varString));
          end
        ///////////
        else
        if Name = 'startdebug' then
          begin
          he_ := fdcmain.Height;
          wi_ := fdcmain.Width;
          to_ := fdcmain.top;
          le_ := fdcmain.left;
          fdcmain.Width := screen.Width;
          fdcmain.Height := screen.Height;
          fdcmain.top := 0;
          fdcmain.left := 0;
          fdcmain.debug.Left := 0;
          fdcmain.debug.top := 0;
          fdcmain.debug.Width := fdcmain.Width;
          fdcmain.debug.Height := fdcmain.Height;
          fdcmain.debug.Visible := True;
          indebug := True;
          Result.Name := Name;
          Result.style := _bool;
          Result.typ := _var;
          Result.state := True;
          end
        ///////////
        ///////////
        else
        if Name = 'enddebug' then
          begin
          fdcmain.debug.Visible := False;
          indebug := False;
          fdcmain.Width := wi_;
          fdcmain.Height := he_;
          fdcmain.Top := to_;
          fdcmain.Left := le_;
          Result.Name := Name;
          Result.style := _bool;
          Result.typ := _var;
          Result.state := True;

          end
        ///////////
        ///////////
        else
        if Name = 'hidewindow' then
          begin
          he_ := fdcmain.Height;
          wi_ := fdcmain.Width;
          to_ := fdcmain.top;
          le_ := fdcmain.left;
          fdcmain.Width := 0;
          fdcmain.Height := 0;
          fdcmain.top := 0;
          fdcmain.left := 0;
          Result.Name := Name;
          Result.style := _bool;
          Result.typ := _var;
          Result.state := True;
          end
        ///////////
        ///////////
        else
        if Name = 'showwindow' then
          begin
          fdcmain.Width := wi_;
          fdcmain.Height := he_;
          fdcmain.Top := to_;
          fdcmain.Left := le_;
          Result.Name := Name;
          Result.style := _bool;
          Result.typ := _var;
          Result.state := True;

          end
        ///////////

        else
        if Name = 'selectelementidx' then
          begin
          selectedelementidx := -1;
          Result.Name := Name;
          Result.style := _int;
          Result.typ := _var;
          if getpureval(line,
            2, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return := DVError;
            exit;
            end;
          application.CreateForm(
            TSelectElement, SelectElement);
          for i :=
            3 to VarAsType(va[2].state, varInteger) + 2 do
            selectelement.
              element.Items.Append(VarAsType(va[i].state, varString));
          selectelement.Caption :=
            VarAsType(va[0].state, varString);
          selectelement.Memo.Text :=
            VarAsType(va[1].state, varString);
          selectelement.showmodal;
          selectelement.Free;
          Result.state :=
            selectedelementidx;
          end

        ///////////

        else
        if Name = 'write' then
          begin
          Result.Name := Name;
          Result.style := _bool;
          Result.typ := _var;
          if getpureval(line,
            1, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return := DVError;
            exit;
            end;
          Result.state := True;
          if va[0].style in
            [_int, _bool, _str] then
            log(va[0].state, False)
          else
            begin
            log(
              '    !', True);
            Result.state := False;
            end;
          end
        else
        if Name = 'eraseallexcept' then
          begin
          Result.Name := Name;
          Result.style := _bool;
          Result.typ := _var;
          if getpureval(line,
            2, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return := DVError;
            exit;
            end;
          Result.state := True;
          s  := va[0].state;
          ex := TStringList.Create;
          for i :=
            2 to VarAsType(va[1].state, varInteger) + 2 do
            ex.Add(
              VarAsType(va[i].state, varString));
          OneDirectoryExName(
            SysUtils.ExcludeTrailingBackslash(
            VarAsType(
            va[0].state, varString)));
          ex.Free;
          Result.state := True;
          end
        else
        if Name =
          'eraseallexceptwipe' then
          begin
          Result.Name := Name;
          Result.style := _bool;
          Result.typ := _var;
          if
          getpureval(line, 2, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return := DVError;
            exit;
            end;
          Result.state := True;
          s  := va[0].state;
          ex := TStringList.Create;
          for i :=
            2 to VarAsType(va[1].state, varInteger) + 2 do
            ex.Add(
              VarAsType(va[i].state, varString));
          OneDirectoryExNameWipe(SysUtils.ExcludeTrailingBackslash(va[0].state));
          ex.Free;
          Result.state := True;
          end

        else
        if Name =
          'erasethisfiles' then
          begin
          Result.Name := Name;
          Result.style := _bool;
          Result.typ := _var;
          if
          getpureval(line, 2, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return := DVError;
            exit;
            end;

          Result.state := True;
          s  := va[0].state;
          ex := TStringList.Create;
          for i :=
            2 to VarAsType(va[1].state, varInteger) + 2 do
            ex.Add(
              VarAsType(va[i].state, varString));
          OneDirectoryOnlyF(SysUtils.ExcludeTrailingBackslash(
            VarAsType(va[0].state, varString)));
          ex.Free;
          Result.state := True;
          end
        else
        if Name =
          'erasethisfileswipe' then
          begin
          Result.Name := Name;
          Result.style := _bool;
          Result.typ := _var;
          if
          getpureval(line, 2, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return := DVError;
            exit;
            end;

          Result.state := True;
          s  := va[0].state;
          ex :=
            TStringList.Create;
          for i :=
            2 to VarAsType(va[1].state, varInteger) + 2 do
            ex.Add(
              VarAsType(va[i].state, varString));
          OneDirectoryOnlyFWipe(
            SysUtils.ExcludeTrailingBackslash(
            VarAsType(
            va[0].state, varString)));
          ex.Free;
          Result.state := True;
          end

        else
        if Name =
          'registerextfunc' then
          begin
          Result.Name := Name;
          Result.style :=
            _bool;
          Result.typ := _var;
          if
          getpureval(line, 4, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return := DVError;
            exit;
            end;

          Result.state := True;
          s := va[0].state;
          if
          AnsiUpperCase(va[2].state) = 'PINTEGER' then
            rt := _pint
          else
          if
          AnsiUpperCase(va[2].state) = 'PWORD' then
            rt := _pword
          else
          if
          AnsiUpperCase(va[2].state) = 'WORD' then
            rt := _word
          else
          if AnsiUpperCase(va[2].state) = 'INTEGER' then
            rt := _int
          else
          if AnsiUpperCase(va[2].state) = 'STRING' then
            rt := _str
          else
          if AnsiUpperCase(va[2].state) = 'BOOL' then
            rt :=
              _bool;

          if
          longint(va[3].state) > 0 then
            begin
            SetLength(
              extpar, longint(va[3].state));
            f := 0;
            for n :=
              4 to longint(va[3].state) + 4 do
              begin
              if
              AnsiUpperCase(va[n].state) = 'PINTEGER' then
                extpar[f] :=
                  _pint
              else
              if AnsiUpperCase(va[n].state) = 'PWORD' then
                extpar[f] :=
                  _pword
              else
              if AnsiUpperCase(va[n].state) = 'WORD' then
                extpar[f]
                := _word
              else
              if AnsiUpperCase(va[n].state) = 'INTEGER' then
                extpar[f]
                := _int
              else
              if
              AnsiUpperCase(va[n].state) = 'STRING' then
                extpar[f] := _str
              else
              if
              AnsiUpperCase(va[n].state) = 'BOOL' then
                extpar
                  [f] := _bool;
              Inc(f);
              end;

            end;


          registerextfunction(
            VarAsType(va[0].state, varString),
            extpar,
            rt, VarAsType(va[1].state, varString));
          Result.state := True;
          end
        else

        if Name =
          'registerextproc' then
          begin
          Result.Name :=
            Name;
          Result.style :=
            _bool;
          Result.typ :=
            _var;
          if
          getpureval(line, 4, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return :=
              DVError;
            exit;
            end;

          Result.state :=
            True;
          s := va[0].state;


          if
          longint(va[2].state) > 0 then
            begin
            SetLength(
              extpar, longint(va[2].state));
            f := 0;
            for n :=
              3 to longint(va[2].state) + 3 do
              begin
              if AnsiUpperCase(va[n].state) = 'PINTEGER' then
                extpar[f] :=
                  _pint
              else
              if AnsiUpperCase(va[n].state) = 'PWORD' then
                extpar
                  [f] :=
                  _pword
              else

              if AnsiUpperCase(va[n].state) = 'WORD' then
                extpar[f]
                := _word
              else

              if
              AnsiUpperCase(va[n].state) = 'INTEGER' then
                extpar[f] := _int
              else
              if
              AnsiUpperCase(va[n].state) = 'STRING' then
                extpar
                  [f] := _str
              else
              if
              AnsiUpperCase(va[n].state) = 'BOOL' then
                extpar
                  [f] := _bool;
              Inc(f);
              end;

            end;


          registerextprocedure(
            VarAsType(va[0].state, varString),
            extpar,
            VarAsType(va[1].state, varString));
          Result.state :=
            True;
          end


        else
        if Name =
          'erasethisfilesnotreq' then
          begin
          Result.Name :=
            Name;
          Result.style :=
            _bool;
          Result.typ :=
            _var;
          if
          getpureval(line, 2, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return :=
              DVError;
            exit;
            end;

          Result.state :=
            True;
          s  := va[0].state;
          ex :=
            TStringList.Create;
          for i :=
            2 to VarAsType(va[1].state, varInteger) + 2 do
            ex.Add(
              VarAsType(va[i].state, varString));
          OneDirectoryOnlyFNR(
            SysUtils.ExcludeTrailingBackslash(
            VarAsType(
            va[0].state, varString)));
          ex.Free;
          Result.state :=
            True;
          end

        else
        if Name =
          'erasethisfilesnotreqwipe' then
          begin
          Result.Name :=
            Name;
          Result.style :=
            _bool;
          Result.typ :=
            _var;
          if
          getpureval(line, 2, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return :=
              DVError;
            exit;
            end;

          Result.state :=
            True;
          s  :=
            va[0].state;
          ex :=
            TStringList.Create;
          for i :=
            2 to VarAsType(va[1].state, varInteger) + 2 do
            ex.Add(
              VarAsType(va[i].state, varString));
          OneDirectoryOnlyFNRWipe(
            SysUtils.ExcludeTrailingBackslash(
            VarAsType(
            va[0].state, varString)));
          ex.Free;
          Result.state :=
            True;
          end

        else
        if Name =
          'erasethisext' then
          begin

          Result.Name
          := Name;
          Result.style
          := _bool;
          Result.typ
          := _var;
          if
          getpureval(line, 2, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return :=
              DVError;
            exit;
            end;
          Result.state
          := True;
          s :=
            va[0].state;
          ex :=
            TStringList.Create;
          for i :=
            2 to VarAsType(va[1].state, varInteger) + 2 do
            ex.Add(
              VarAsType(va[i].state, varString));
          OneDirectoryByExt(
            SysUtils.ExcludeTrailingBackslash(
            VarAsType(va
            [0].state, varString)));
          ex.Free;
          Result.state
          := True;
          end
        else
        if Name =
          'erasethisextwipe' then
          begin

          Result.Name
          := Name;
          Result.style
          := _bool;
          Result.typ
          := _var;
          if getpureval(line, 2, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return :=
              DVError;
            exit;
            end;
          Result.state
          := True;
          s :=
            va[0].state;
          ex :=
            TStringList.Create;
          for i :=
            2 to VarAsType(va[1].state, varInteger) + 2 do
            ex.Add(
              VarAsType(va[i].state, varString));
          OneDirectoryByExtWipe(
            SysUtils.ExcludeTrailingBackslash(
            VarAsType(
            va[0].state, varString)));
          ex.Free;
          Result.state
          := True;
          end

        else
        if Name =
          'erasethisextnotreq' then
          begin

          Result.Name
          := Name;
          Result.style
          := _bool;
          Result.typ
          := _var;
          if getpureval(line, 2, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return :=
              DVError;
            exit;
            end;
          Result.state
          := True;
          s :=
            va[0].state;
          ex :=
            TStringList.Create;
          for i :=
            2 to VarAsType(va[1].state, varInteger) + 2 do
            ex.Add(
              VarAsType(va[i].state, varString));
          OneDirectoryByExtNR(
            SysUtils.ExcludeTrailingBackslash(
            VarAsType(
            va[0].state, varString)));
          ex.Free;
          Result.state
          := True;
          end

        /////////////////////////////////////////
         else
        if Name =
          'calculate' then
          begin

          Result.Name
          := Name;
          Result.style
          := _int;
          Result.typ
          := _var;
          if getpureval(line, 2, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return :=
              DVError;
            exit;
            end;
          Result.state := True;

          EP:= TCustomParser.Create(nil);
          for i := 2 to va[1].ascardinal + 1 do

           begin
           EP.Variable[va[i].varname] := va[i].ascardinal;
           end;
          EP.Expression:=va[0].state;
          Result.state       := EP.Value;
          EP.Free;
          end
          else
        ////////////////////////////////////////
        if Name =
          'erasethisextnotreqwipe' then
          begin

          Result.Name
          := Name;
          Result.style
          := _bool;
          Result.typ
          := _var;
          if getpureval(line, 2, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return
            := DVError;
            exit;
            end;
          Result.state
          := True;
          s :=
            va[0].state;
          ex :=
            TStringList.Create;
          for
            i :=
            2 to VarAsType(va[1].state, varInteger) + 2 do
            ex.Add(VarAsType(va[i].state, varString));
          OneDirectoryByExtNRWipe(
            SysUtils.ExcludeTrailingBackslash(
            VarAsType(
            va[0].state, varString)));
          ex.Free;
          Result.state
          := True;
          end

        else
        if
        Name = 'erasethismasknotreq' then
          begin

          Result.Name := Name;
          Result.
            style := _bool;
          Result.typ := _var;
          if
          getpureval(line, 2, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return
            := DVError;
            exit;
            end;
          Result.
            state := True;
          s  :=
            va[0].state;
          ex :=
            TStringList.Create;
          for
            i :=
            2 to VarAsType(va[1].state, varInteger) + 2 do
            ex.Add(VarAsType(va[i].state, varString));
          OneDirectoryByMaskNR(
            SysUtils.ExcludeTrailingBackslash(
            VarAsType(
            va[0].state, varString)));
          ex.Free;
          Result.
            state := True;
          end
        else
        if Name
          = 'erasethismasknotreqwipe' then
          begin

          Result.Name := Name;
          Result.
            style := _bool;
          Result.typ := _var;
          if
          getpureval(line, 2, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return
            := DVError;
            exit;
            end;
          Result.
            state := True;
          s  :=
            va[0].state;
          ex :=
            TStringList.Create;
          for
            i
            := 2 to VarAsType(va[1].state, varInteger) + 2 do
            ex.
              Add(VarAsType(va[i].state, varString));
          OneDirectoryByMaskNRWipe(
            SysUtils.ExcludeTrailingBackslash(
            VarAsType(
            va[0].state, varString)));
          ex.Free;
          Result.
            state := True;
          end

        else
        if Name
          = 'eraseallfiles' then
          begin
          Result.Name := Name;
          Result.
            style := _bool;
          Result.typ := _var;
          if
          getpureval(line, 1, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return
            := DVError;
            exit;
            end;
          Result.
            state := True;
          s :=
            va[0].state;
          OneDirectoryAll(
            SysUtils.ExcludeTrailingBackslash(va[0].state));
          Result.
            state := True;
          end
        else
        if
        Name = 'eraseallfileswipe' then
          begin
          Result.Name := Name;
          Result.
            style := _bool;
          Result.typ := _var;
          if
          getpureval(line, 1, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return
            := DVError;
            exit;
            end;
          Result.
            state := True;
          s
          :=
            va[0].state;
          OneDirectoryAllWipe(
            SysUtils.ExcludeTrailingBackslash(va[0].state));
          Result.
            state := True;
          end

        else
        if
        Name = 'eraseextbyage' then
          begin
          Result.Name := Name;
          Result.
            style := _bool;
          Result.typ
          := _var;
          if
          getpureval(line, 3, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return
            :=
              DVError;
            exit;
            end;

          Result.
            state := True;
          s
          :=
            va[0].state;
          OneDirectoryAge(
            SysUtils.ExcludeTrailingBackslash(
            VarAsType(
            va[0].state, varString)),
            VarAsType(
            va[1].state, varString), VarAsType(va[2].state, varInteger));
          Result.
            state := True;
          end
        else
        if
        Name = 'eraseextbyagewipe' then
          begin
          Result.Name
          := Name;
          Result.style
          := _bool;
          Result.typ
          := _var;
          if
          getpureval(line, 3, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return
            :=
              DVError;
            exit;
            end;

          Result.state
          := True;
          s
          :=
            va[0].state;
          OneDirectoryAgeWipe(
            SysUtils.ExcludeTrailingBackslash(
            VarAsType(
            va[0].state, varString)),
            VarAsType(
            va[1].state, varString), VarAsType(va[2].state, varInteger));
          Result.state
          := True;
          end

        else
        if
        Name = 'readln' then
          begin
          Result.Name
          := Name;
          Result.style
          := _str;
          Result.typ
          := _var;
          Result.state
          := InputBox(' FDK', '', '');
          end

        else
        if
        Name = 'random' then
          begin
          Result.Name
          := Name;
          Result.style
          := _int;
          Result.typ
          := _var;
          Result.state
          := Random();
          end

        else
        if
        Name = 'readlnex' then
          begin
          Result.Name
          := Name;
          Result.style
          := _str;
          Result.typ
          := _var;
          Result.state
          := '';
          if
          getpureval(line, 3, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return
            :=
              DVError;
            exit;
            end;

          Result.state
          := InputBox(va[0].state, va[1].state, va[2].state);
          end
        else
        if
        Name = 'pos' then
          begin
          Result.Name
          := Name;
          Result.style
          := _int;
          Result.typ
          := _var;
          Result.state
          := -1;
          if
          getpureval(line, 2, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return
            :=
              DVError;
            exit;
            end;
          Result.state
          := pos(VarAsType(va[0].state, varString),
            VarAsType(
            va[1].state, varString));
          end

        else
        if
        Name = 'halt' then
          begin
          Result.Name
          := Name;
          Result.style
          := _bool;
          Result.typ
          := _var;
          Result.state
          := True;
          currentline
          :=
            linecount - 1;
          end
        else
        if
        Name = 'strcat' then
          begin
          Result.Name
          := Name;
          Result.style
          := _str;
          Result.typ
          := _var;
          if
          getpureval(line, 2, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return
            :=
              DVError;
            exit;
            end;
          Result.state
          := va[0].state + va[1].state;
          end

        else
        if
        Name = 'inc' then

          begin
          Result.Name
          := Name;
          Result.style
          := _int;
          Result.typ
          := _var;
          if
          getpureval(line, 2, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return
            :=
              DVError;
            exit;
            end;
          Result.state := Integer(va[0].state) + Integer(va[1].state);
          end

        else
        if
        Name = 'dec' then
          begin
          Result.Name
          := Name;
          Result.style
          := _int;
          Result.typ
          := _var;
          if
          getpureval(line, 2, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return
            :=
              DVError;
            exit;
            end;
          Result.state
          := va[0].state - va[1].state;
          end
        else
        if
        Name = 'mul' then
          begin
          Result.Name
          := Name;
          Result.style
          := _int;
          Result.typ
          := _var;
          if
          getpureval(line, 2, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return
            :=
              DVError;
            exit;
            end;
          Result.state
          := va[0].state * va[1].state;
          end
        else
        if
        Name = 'div' then
          begin
          Result.Name
          := Name;
          Result.style
          := _int;
          Result.typ
          := _var;
          if
          getpureval(line, 2, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return
            :=
              DVError;
            exit;
            end;
          Result.state
          := va[0].state div va[1].state;
          end
        else
        if
        Name = 'mod' then
          begin
          Result.Name
          := Name;
          Result.style
          := _int;
          Result.typ
          := _var;
          if
          getpureval(line, 2, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return
            :=
              DVError;
            exit;
            end;
          Result.state
          := va[0].state mod va[1].state;
          end
        else
        if
        Name = 'shr' then
          begin
          Result.Name
          := Name;
          Result.style
          := _int;
          Result.typ
          := _var;
          if
          getpureval(line, 2, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return
            :=
              DVError;
            exit;
            end;
          Result.state
          := va[0].state shr va[1].state;
          end
        else
        if
        Name = 'shl' then
          begin
          Result.Name
          := Name;
          Result.style
          := _int;
          Result.typ
          := _var;
          if
          getpureval(line, 2, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return
            :=
              DVError;
            exit;
            end;
          Result.state
          := va[0].state shl va[1].state;
          end
        else
        if
        Name = 'rol' then
          begin
          Result.Name
          := Name;
          Result.style
          := _int;
          Result.typ
          := _var;
          if
          getpureval(line, 2, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return
            :=
              DVError;
            exit;
            end;
          Result.state
          := rol32(va[0].state, va[1].state);
          end
        else
        if
        Name = 'ror' then
          begin
          Result.Name
          := Name;
          Result.style
          := _int;
          Result.typ
          := _var;
          if
          getpureval(line, 2, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return
            :=
              DVError;
            exit;
            end;
          Result.state
          := ror32(va[0].state, va[1].state);
          end
        else
        if
        Name = 'xor' then
          begin
          Result.Name
          := Name;
          Result.style
          := _int;
          Result.typ
          := _var;
          if
          getpureval(line, 2, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return
            :=
              DVError;
            exit;
            end;
          Result.state
          := va[0].state xor va[1].state;
          end
        else
        if
        Name = 'or' then
          begin
          Result.Name
          := Name;
          Result.style
          := _int;
          Result.typ
          := _var;
          if
          getpureval(line, 2, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return
            :=
              DVError;
            exit;
            end;
          Result.state
          := va[0].state or va[1].state;
          end
        else
        if
        Name = 'and' then
          begin
          Result.Name
          := Name;
          Result.style
          := _int;
          Result.typ
          := _var;
          if
          getpureval(line, 2, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return :=
              DVError;
            exit;
            end;
          Result.state
          := va[0].state and va[1].state;
          end
        else
        if
        Name = 'randomrange' then
          begin
          Result.Name := Name;
          Result.style := _int;
          Result.typ
          := _var;
          if
          getpureval(line, 2, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return :=
              DVError;
            exit;
            end;
          Result.state := RandomRange(va[0].state, va[1].state);
          end

        else
        if
        Name = 'not' then
          begin
          Result.Name := Name;
          Result.style := _int;
          Result.typ := _var;
          if
          getpureval(line, 1, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return :=
              DVError;
            exit;
            end;
          Result.state := -(va[0].state);
          end

        else
        /////
        if
        Name = 'regopenkey' then
          begin
          Result.Name := Name;
          Result.style := _bool;
          Result.typ := _var;
          if
          getpureval(line, 1, va) <> dvok then
            begin
            log(
              '      ' + Result.Name, True);
            Return :=
              DVError;
            exit;
            end;
          if
          reg.KeyExists(va[0].state) then
            Result.state := reg.OpenKey(va[0].state)
          else
            Result.state := False;
          end
        else ////
        /////
        if
        Name = 'regopenkeya' then
          begin
          Result.Name := Name;
          Result.style := _bool;
          Result.typ := _var;
          if
          getpureval(line, 1, va) <> dvok then
            begin
            log('      ' + Result.Name, True);
            Return :=
              DVError;
            exit;
            end;
          Result.state := reg.OpenKey(va[0].state);
          end
        else ////
        /////
        if
        Name = 'regcreatekey' then
          begin
          Result.Name := Name;
          Result.style := _bool;
          Result.typ := _var;
          if
          getpureval(line, 1, va) <> dvok then
            begin
            log('      ' + Result.Name, True);
            Return := DVError;
            exit;
            end;
          Result.state := reg.CreateKey(va[0].state);
          end
        else ////
        if
        Name = 'regclosekey' then
          begin
          Result.Name := Name;
          Result.style := _bool;
          Result.typ := _var;
          Result.state := True;
          reg.CloseKey;
          end
        else        ////
        if Name = 'regopenrootkey' then
          begin
          Result.Name := Name;
          Result.style := _bool;
          Result.typ := _var;
          if getpureval(line, 1, va) <> dvok then
            begin
            log('      ' + Result.Name, True);
            Return := DVError;
            exit;
            end;
          Result.state := True;
          if UpperCase(VarAsType(va[0].state, varString)) = 'HKCU' then
            reg.RootKey := HKEY_CURRENT_USER
          else
          if UpperCase(VarAsType(va[0].state, varString)) = 'HKLM' then
            reg.RootKey := HKEY_LOCAL_MACHINE
          else
          if UpperCase(VarAsType(va[0].state, varString)) = 'HKCC' then
            reg.RootKey := HKEY_CURRENT_CONFIG
          else
          if UpperCase(VarAsType(va[0].state, varString)) = 'HKU' then
            reg.RootKey := HKEY_USERS
          else
          if UpperCase(VarAsType(va[0].state, varString)) = 'HKCR' then
            reg.RootKey  := HKEY_CLASSES_ROOT
          else
            Result.state := False;
          end
        else        ////
        ////
        if Name = 'regwritestring' then
          begin
          Result.Name := Name;
          Result.style := _bool;
          Result.typ := _var;
          if getpureval(line, 2, va) <> dvok then
            begin
            log('      ' + Result.Name, True);
            Return := DVError;
            exit;
            end;
          Result.state := True;
          reg.WriteString(va[0].state, va[1].state);
          end
        else ////
        ////
        if Name = 'regwriteinteger' then
          begin
          Result.Name := Name;
          Result.style := _bool;
          Result.typ := _var;
          if getpureval(line, 2, va) <> dvok then
            begin
            log('      ' + Result.Name, True);
            Return := DVError;
            exit;
            end;
          Result.state := True;
          reg.WriteInteger(VarAsType(va[0].state, varString),
            VarAsType(va[1].state, varInteger));
          end
        else ////
        ////
        if Name = 'regdeletevalue' then
          begin
          Result.Name := Name;
          Result.style := _bool;
          Result.typ := _var;
          if getpureval(line, 1, va) <> dvok then
            begin
            log('      ' + Result.Name, True);
            Return := DVError;
            exit;
            end;
          Result.state := True;
          reg.DeleteValue(va[0].state);
          end

        else ////

        if Name = 'setntservicestate' then
          begin
          Result.Name := Name;
          Result.style := _bool;
          Result.typ := _var;
          if getpureval(line, 2, va) <> dvok then
            begin
            log('      ' + Result.Name, True);
            Return := DVError;
            exit;
            end;
          Result.state := ApplyServices(va[0].state, va[1].state);
          ///////////////////
          end
        else ////
        if Name = 'getntservicestate' then
          begin
          Result.Name := Name;
          Result.style := _bool;
          Result.typ := _var;
          if getpureval(line, 1, va) <> dvok then
            begin
            log('      ' + Result.Name, True);
            Return := DVError;
            exit;
            end;
          Result.state := GetServices(va[0].state);
          ///////////////////
          end
        else
        ////
        if Name = 'regwritebool' then
          begin
          Result.Name := Name;
          Result.style := _bool;
          Result.typ := _var;
          if getpureval(line, 2, va) <> dvok then
            begin
            log('      ' + Result.Name, True);
            Return := DVError;
            exit;
            end;
          Result.state := True;
          reg.WriteBool(va[0].state, va[1].state);
          end
        else ////
        ////
        if Name = 'regreadinteger' then
          begin
          Result.Name := Name;
          Result.style := _int;
          Result.typ := _var;
          if getpureval(line, 1, va) <> dvok then
            begin
            log('      ' + Result.Name, True);
            Return := DVError;
            exit;
            end;
          Result.state := reg.ReadInteger(va[0].state);
          end
        else ////
        ////
        if Name = 'regreadstring' then
          begin
          Result.Name := Name;
          Result.style := _str;
          Result.typ := _var;
          if getpureval(line, 1, va) <> dvok then
            begin
            log('      ' + Result.Name, True);
            Return := DVError;
            exit;
            end;
          Result.state := reg.ReadString(va[0].state);
          end
        else ////
        ////
        if Name = 'regreadbool' then
          begin
          Result.Name := Name;
          Result.style := _bool;
          Result.typ := _var;
          if getpureval(line, 1, va) <> dvok then
            begin
            log('      ' + Result.Name, True);
            Return := DVError;
            exit;
            end;
          Result.state := reg.ReadBool(va[0].state);
          end
        else ////
        ////
        if Name = 'regkeyexists' then
          begin
          Result.Name := Name;
          Result.style := _bool;
          Result.typ := _var;
          Result.state := False;
          if getpureval(line, 1, va) <> dvok then
            begin
            log('      ' + Result.Name, True);
            Return := DVError;
            exit;
            end;
          Result.state := reg.KeyExists(va[0].state);
          end
        else ////
        ////
        if Name = 'regvalueexists' then
          begin
          Result.Name := Name;
          Result.style := _bool;
          Result.typ := _var;
          if getpureval(line, 1, va) <> dvok then
            begin
            log('      ' + Result.Name, True);
            Return := DVError;
            exit;
            end;
          Result.state := reg.ValueExists(va[0].state);
          end


        else        ////
        if Name = 'regautostartremove' then
          begin
          Result.Name := Name;
          Result.style := _bool;
          Result.typ := _var;
          if getpureval(line, 2, va) <> dvok then
            begin
            log('      ' + Result.Name, True);
            Return := DVError;
            exit;
            end;
          Result.state := True;
          if UpperCase(VarAsType(va[0].state, varString)) = 'HKCU' then
            reg.RootKey := HKEY_CURRENT_USER
          else
          if UpperCase(VarAsType(va[0].state, varString)) = 'HKLM' then
            reg.RootKey := HKEY_LOCAL_MACHINE
          else
          if UpperCase(VarAsType(va[0].state, varString)) = 'HKCC' then
            reg.RootKey := HKEY_CURRENT_CONFIG
          else
          if UpperCase(VarAsType(va[0].state, varString)) = 'HKU' then
            reg.RootKey := HKEY_USERS
          else
          if UpperCase(VarAsType(va[0].state, varString)) = 'HKCR' then
            reg.RootKey  := HKEY_CLASSES_ROOT
          else
            Result.state := False;
          if reg.KeyExists('\SOFTWARE\Microsoft\Windows\CurrentVersion\Run') then
            begin
            reg.OpenKey('\SOFTWARE\Microsoft\Windows\CurrentVersion\Run');
            if reg.ValueExists(va[1].state) then
              reg.DeleteValue(va[1].state);
            Result.state := True;
            end
          else
            begin
            Result.state := False;
            end;

          if reg.KeyExists('\SOFTWARE\Microsoft\Windows\CurrentVersion\RunOnce') then
            begin
            reg.OpenKey('\SOFTWARE\Microsoft\Windows\CurrentVersion\RunOnce');
            if reg.ValueExists(va[1].state) then
              reg.DeleteValue(va[1].state);
            Result.state := True;
            end
          else
            begin
            // result.state:=False;
            end;

          if reg.KeyExists('\SOFTWARE\Microsoft\Windows\CurrentVersion\RunOnceEx') then
            begin
            reg.OpenKey('\SOFTWARE\Microsoft\Windows\CurrentVersion\RunOnceEx');
            if reg.ValueExists(va[1].state) then
              reg.DeleteValue(va[1].state);
            Result.state := True;
            end
          else
            begin
            // result.state:=False;
            end;

          reg.CloseKey;

          end


        else ////
        ////
        if Name = 'regdeletekey' then
          begin
          Result.Name := Name;
          Result.style := _bool;
          Result.typ := _var;
          if getpureval(line, 1, va) <> dvok then
            begin
            log('      ' + Result.Name, True);
            Return := DVError;
            exit;
            end;
          Result.state := reg.DeleteKey(va[0].state);
          end

        else ////
        ////
        if Name = 'help' then
          begin
          log(' : ', False);
          log('-----------------', False);

          Result.Name := Name;
          Result.style := _bool;
          Result.typ := _var;

          for f := 0 to length(langrec) - 1 do
            begin
            pa := Format('%d: ', [f]);
            case langrec[f].calltype of
              _proc:
                pa := pa + 'procedure ';
              _func:
                pa := pa + 'function ';
              end;
            pa := pa + langrec[f].Name + '(';

            if length(langrec[f].params) > 0 then

              for n := 0 to length(langrec[f].params) - 1 do
                begin
                case langrec[f].params[n] of
                  _pint:
                    pa := pa + ' PInteger ';
                  _pword:
                    pa := pa + ' PWord ';
                  _word:
                    pa := pa + ' Word ';
                  _int:
                    pa := pa + ' Integer ';
                  _str:
                    pa := pa + ' String ';
                  _bool:
                    pa := pa + ' Bool ';
                  _err:
                    pa := pa + ' Error ';
                  end;
                end;

            pa := pa + ')';

            if langrec[f].calltype = _func then
              begin
              case langrec[f].Result of
                _pint:
                  pa := pa + ' :PInteger ';
                _pword:
                  pa := pa + ' :PWord ';
                _word:
                  pa := pa + ' :Word ';
                _int:
                  pa := pa + ' :Integer ';
                _str:
                  pa := pa + ' :String ';
                _bool:
                  pa := pa + ' :Bool ';
                _err:
                  pa := pa + ' :Error ';
                end;

              end;


            log(pa, False);
            end;

          ///
          for f := 0 to length(extlangrec) - 1 do
            begin
            pa := Format('%d: ', [f]);
            case extlangrec[f].calltype of
              _proc:
                pa := pa + 'extprocedure ';
              _func:
                pa := pa + 'extfunction ';
              end;
            pa := pa + extlangrec[f].Name + '(';

            if length(extlangrec[f].params) > 0 then

              for n := 0 to length(extlangrec[f].params) - 1 do
                begin
                case extlangrec[f].params[n] of
                  _pint:
                    pa := pa + ' PInteger ';
                  _pword:
                    pa := pa + ' PWord ';
                  _word:
                    pa := pa + ' Word ';
                  _int:
                    pa := pa + ' Integer ';
                  _str:
                    pa := pa + ' String ';
                  _bool:
                    pa := pa + ' Bool ';
                  _err:
                    pa := pa + ' Error ';
                  end;
                end;

            pa := pa + ')';

            if extlangrec[f].calltype = _func then
              begin
              case extlangrec[f].Result of
                _pint:
                  pa := pa + ' :PInteger ';
                _pword:
                  pa := pa + ' :PWord ';
                _word:
                  pa := pa + ' :Word ';
                _int:
                  pa := pa + ' :Integer ';
                _str:
                  pa := pa + ' :String ';
                _bool:
                  pa := pa + ' :Bool ';
                _err:
                  pa := pa + ' :Error ';
                end;

              end;


            log(pa, False);
            end;

          ///


          log(' ', False);
          log('-------------', False);
          Result.state := True;

          end

        else

        if FindInt(Name) <> -1 then
          begin
          Result.Name := Name;

          f := FindInt(Name);

          if LangRec[f].calltype = _func then
            Result.style := LangRec[f].Result
          else
            Result.style := _bool;
          Result.typ := _var;


          if Length(LangRec[f].params) > 0 then
            begin

            if getpureval(line, Length(LangRec[f].params), va) <> dvok then
              begin
              log('      ' + Result.Name, True);
              Return := DVError;
              exit;
              end;
            end;

          if LangRec[f].calltype = _proc then
            begin
            Result.state := True;


            case Length(langrec[f].params) of
              0:
                TVarProc0(LangRec[f].point)();
              1:
                TVarProc1(LangRec[f].point)(va[0].ascardinal);
              2:
                TVarProc2(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal);
              3:
                TVarProc3(LangRec[f].point)(va[0].ascardinal,
                  va[1].ascardinal, va[2].ascardinal);
              4:
                TVarProc4(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal,
                  va[2].ascardinal, va[3].ascardinal);
              5:
                TVarProc5(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal,
                  va[2].ascardinal, va[3].ascardinal, va[4].ascardinal);
              6:
                TVarProc6(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal,
                  va[2].ascardinal, va[3].ascardinal, va[4].ascardinal,
                  va[5].ascardinal);
              7:
                TVarProc7(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal,
                  va[2].ascardinal, va[3].ascardinal, va[4].ascardinal,
                  va[5].ascardinal, va[6].ascardinal);

              end;

            end
          else

            begin
            // function


            case langrec[f].Result of
              _str:
                begin
                case Length(langrec[f].params) of
                  0:
                    Result.state := TVarFunc0s(LangRec[f].point);
                  1:
                    Result.state := TVarFunc1s(LangRec[f].point)(va[0].ascardinal);
                  2:
                    Result.state :=
                      TVarFunc2s(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal);
                  3:
                    Result.state :=
                      TVarFunc3s(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal, va[2].ascardinal);
                  4:
                    Result.state :=
                      TVarFunc4s(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal, va[2].ascardinal, va[3].ascardinal);
                  5:
                    Result.state :=
                      TVarFunc5s(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal, va[2].ascardinal, va[3].ascardinal, va[4].ascardinal);
                  6:
                    Result.state :=
                      TVarFunc6s(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal, va[2].ascardinal, va[3].ascardinal, va[4].ascardinal, va[5].ascardinal);
                  7:
                    Result.state :=
                      TVarFunc7s(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal, va[2].ascardinal, va[3].ascardinal, va[4].ascardinal, va[5].ascardinal, va[6].ascardinal);

                  end;
                end;

              _int:
                begin
                case Length(langrec[f].params) of
                  0:
                    Result.state := TVarFunc0i(LangRec[f].point);
                  1:
                    Result.state := TVarFunc1i(LangRec[f].point)(va[0].ascardinal);
                  2:
                    Result.state :=
                      TVarFunc2i(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal);
                  3:
                    Result.state :=
                      TVarFunc3i(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal, va[2].ascardinal);
                  4:
                    Result.state :=
                      TVarFunc4i(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal, va[2].ascardinal, va[3].ascardinal);
                  5:
                    Result.state :=
                      TVarFunc5i(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal, va[2].ascardinal, va[3].ascardinal, va[4].ascardinal);
                  6:
                    Result.state :=
                      TVarFunc6i(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal, va[2].ascardinal, va[3].ascardinal, va[4].ascardinal, va[5].ascardinal);
                  7:
                    Result.state :=
                      TVarFunc7i(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal, va[2].ascardinal, va[3].ascardinal, va[4].ascardinal, va[5].ascardinal, va[6].ascardinal);

                  end;
                end;

              _pword:
                begin
                case Length(langrec[f].params) of
                  0:
                    Result.state := TVarFunc0i(LangRec[f].point);
                  1:
                    Result.state := TVarFunc1i(LangRec[f].point)(va[0].ascardinal);
                  2:
                    Result.state :=
                      TVarFunc2i(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal);
                  3:
                    Result.state :=
                      TVarFunc3i(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal, va[2].ascardinal);
                  4:
                    Result.state :=
                      TVarFunc4i(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal, va[2].ascardinal, va[3].ascardinal);
                  5:
                    Result.state :=
                      TVarFunc5i(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal, va[2].ascardinal, va[3].ascardinal, va[4].ascardinal);
                  6:
                    Result.state :=
                      TVarFunc6i(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal, va[2].ascardinal, va[3].ascardinal, va[4].ascardinal, va[5].ascardinal);
                  7:
                    Result.state :=
                      TVarFunc7i(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal, va[2].ascardinal, va[3].ascardinal, va[4].ascardinal, va[5].ascardinal, va[6].ascardinal);

                  end;
                end;

              _pint:
                begin
                case Length(langrec[f].params) of
                  0:
                    Result.state := TVarFunc0i(LangRec[f].point);
                  1:
                    Result.state := TVarFunc1i(LangRec[f].point)(va[0].ascardinal);
                  2:
                    Result.state :=
                      TVarFunc2i(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal);
                  3:
                    Result.state :=
                      TVarFunc3i(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal, va[2].ascardinal);
                  4:
                    Result.state :=
                      TVarFunc4i(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal, va[2].ascardinal, va[3].ascardinal);
                  5:
                    Result.state :=
                      TVarFunc5i(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal, va[2].ascardinal, va[3].ascardinal, va[4].ascardinal);
                  6:
                    Result.state :=
                      TVarFunc6i(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal, va[2].ascardinal, va[3].ascardinal, va[4].ascardinal, va[5].ascardinal);
                  7:
                    Result.state :=
                      TVarFunc7i(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal, va[2].ascardinal, va[3].ascardinal, va[4].ascardinal, va[5].ascardinal, va[6].ascardinal);

                  end;
                end;


              _word:
                begin
                case Length(langrec[f].params) of
                  0:
                    Result.state := TVarFunc0i(LangRec[f].point);
                  1:
                    Result.state := TVarFunc1i(LangRec[f].point)(va[0].ascardinal);
                  2:
                    Result.state :=
                      TVarFunc2i(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal);
                  3:
                    Result.state :=
                      TVarFunc3i(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal, va[2].ascardinal);
                  4:
                    Result.state :=
                      TVarFunc4i(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal, va[2].ascardinal, va[3].ascardinal);
                  5:
                    Result.state :=
                      TVarFunc5i(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal, va[2].ascardinal, va[3].ascardinal, va[4].ascardinal);
                  6:
                    Result.state :=
                      TVarFunc6i(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal, va[2].ascardinal, va[3].ascardinal, va[4].ascardinal, va[5].ascardinal);
                  7:
                    Result.state :=
                      TVarFunc7i(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal, va[2].ascardinal, va[3].ascardinal, va[4].ascardinal, va[5].ascardinal, va[6].ascardinal);

                  end;
                end;


              _bool:
                begin
                case Length(langrec[f].params) of
                  0:
                    Result.state := TVarFunc0b(LangRec[f].point);
                  1:
                    Result.state := TVarFunc1b(LangRec[f].point)(va[0].ascardinal);
                  2:
                    Result.state :=
                      TVarFunc2b(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal);
                  3:
                    Result.state :=
                      TVarFunc3b(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal, va[2].ascardinal);
                  4:
                    Result.state :=
                      TVarFunc4b(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal, va[2].ascardinal, va[3].ascardinal);
                  5:
                    Result.state :=
                      TVarFunc5b(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal, va[2].ascardinal, va[3].ascardinal, va[4].ascardinal);
                  6:
                    Result.state :=
                      TVarFunc6b(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal, va[2].ascardinal, va[3].ascardinal, va[4].ascardinal, va[5].ascardinal);
                  7:
                    Result.state :=
                      TVarFunc7b(LangRec[f].point)(va[0].ascardinal, va[1].ascardinal, va[2].ascardinal, va[3].ascardinal, va[4].ascardinal, va[5].ascardinal, va[6].ascardinal);

                  end;
                end;

              end;

            end;
          /////////////////////////////

          fixpointers(va);
          ////////////////////////////
          end
        else
        if findext(Name) <> -1 then

          begin
          Result.Name := Name;

          f := FindExt(Name);

          if extlangrec[f].calltype = _func then
            Result.style := extlangrec[f].Result
          else
            Result.style := _bool;
          Result.typ := _var;


          if Length(extlangrec[f].params) > 0 then
            begin

            if getpureval(line, Length(extlangrec[f].params), va) <> dvok then
              begin
              log('      ' + Result.Name, True);
              Return := DVError;
              exit;
              end;
            end;

          if extlangrec[f].calltype = _proc then
            begin
            Result.state := True;


            case Length(extlangrec[f].params) of
              0:
                TVarProc0ext(extlangrec[f].point)();
              1:
                TVarProc1ext(extlangrec[f].point)(va[0].ascardinalext);
              2:
                TVarProc2ext(extlangrec[f].point)(va[0].ascardinalext,
                  va[1].ascardinalext);
              3:
                TVarProc3ext(extlangrec[f].point)(va[0].ascardinalext,
                  va[1].ascardinalext, va[2].ascardinalext);
              4:
                TVarProc4ext(extlangrec[f].point)(va[0].ascardinalext,
                  va[1].ascardinalext,
                  va[2].ascardinalext, va[3].ascardinalext);
              5:
                TVarProc5ext(extlangrec[f].point)(va[0].ascardinalext,
                  va[1].ascardinalext,
                  va[2].ascardinalext, va[3].ascardinalext, va[4].ascardinalext);
              6:
                TVarProc6ext(extlangrec[f].point)(va[0].ascardinalext,
                  va[1].ascardinalext,
                  va[2].ascardinalext, va[3].ascardinalext, va[4].ascardinalext,
                  va[5].ascardinalext);
              7:
                TVarProc7ext(extlangrec[f].point)(va[0].ascardinalext,
                  va[1].ascardinalext,
                  va[2].ascardinalext, va[3].ascardinalext, va[4].ascardinalext,
                  va[5].ascardinalext, va[6].ascardinalext);

              end;

            end
          else

            begin
            // function


            case extlangrec[f].Result of
              _str:
                begin
                case Length(extlangrec[f].params) of
                  0:
                    Result.state := TVarFunc0sext(extlangrec[f].point);
                  1:
                    Result.state :=
                      TVarFunc1sext(extlangrec[f].point)(va[0].ascardinalext);
                  2:
                    Result.state :=
                      TVarFunc2sext(extlangrec[f].point)(va[0].ascardinalext, va[1].ascardinalext);
                  3:
                    Result.state :=
                      TVarFunc3sext(extlangrec[f].point)(va[0].ascardinalext, va[1].ascardinalext, va[2].ascardinalext);
                  4:
                    Result.state :=
                      TVarFunc4sext(extlangrec[f].point)(va[0].ascardinalext, va[1].ascardinalext, va[2].ascardinalext, va[3].ascardinalext);
                  5:
                    Result.state :=
                      TVarFunc5sext(extlangrec[f].point)(va[0].ascardinalext, va[1].ascardinalext, va[2].ascardinalext, va[3].ascardinalext, va[4].ascardinalext);
                  6:
                    Result.state :=
                      TVarFunc6sext(extlangrec[f].point)(va[0].ascardinalext, va[1].ascardinalext, va[2].ascardinalext, va[3].ascardinalext, va[4].ascardinalext, va[5].ascardinalext);
                  7:
                    Result.state :=
                      TVarFunc7sext(extlangrec[f].point)(va[0].ascardinalext, va[1].ascardinalext, va[2].ascardinalext, va[3].ascardinalext, va[4].ascardinalext, va[5].ascardinalext, va[6].ascardinalext);

                  end;
                end;

              _int:
                begin
                case Length(extlangrec[f].params) of
                  0:
                    Result.state := TVarFunc0iext(extlangrec[f].point);
                  1:
                    Result.state :=
                      TVarFunc1iext(extlangrec[f].point)(va[0].ascardinalext);
                  2:
                    Result.state :=
                      TVarFunc2iext(extlangrec[f].point)(va[0].ascardinalext, va[1].ascardinalext);
                  3:
                    Result.state :=
                      TVarFunc3iext(extlangrec[f].point)(va[0].ascardinalext, va[1].ascardinalext, va[2].ascardinalext);
                  4:
                    Result.state :=
                      TVarFunc4iext(extlangrec[f].point)(va[0].ascardinalext, va[1].ascardinalext, va[2].ascardinalext, va[3].ascardinalext);
                  5:
                    Result.state :=
                      TVarFunc5iext(extlangrec[f].point)(va[0].ascardinalext, va[1].ascardinalext, va[2].ascardinalext, va[3].ascardinalext, va[4].ascardinalext);
                  6:
                    Result.state :=
                      TVarFunc6iext(extlangrec[f].point)(va[0].ascardinalext, va[1].ascardinalext, va[2].ascardinalext, va[3].ascardinalext, va[4].ascardinalext, va[5].ascardinalext);
                  7:
                    Result.state :=
                      TVarFunc7iext(extlangrec[f].point)(va[0].ascardinalext, va[1].ascardinalext, va[2].ascardinalext, va[3].ascardinalext, va[4].ascardinalext, va[5].ascardinalext, va[6].ascardinalext);

                  end;
                end;

              _pint:
                begin
                case Length(extlangrec[f].params) of
                  0:
                    Result.state := TVarFunc0iext(extlangrec[f].point);
                  1:
                    Result.state :=
                      TVarFunc1iext(extlangrec[f].point)(va[0].ascardinalext);
                  2:
                    Result.state :=
                      TVarFunc2iext(extlangrec[f].point)(va[0].ascardinalext, va[1].ascardinalext);
                  3:
                    Result.state :=
                      TVarFunc3iext(extlangrec[f].point)(va[0].ascardinalext, va[1].ascardinalext, va[2].ascardinalext);
                  4:
                    Result.state :=
                      TVarFunc4iext(extlangrec[f].point)(va[0].ascardinalext, va[1].ascardinalext, va[2].ascardinalext, va[3].ascardinalext);
                  5:
                    Result.state :=
                      TVarFunc5iext(extlangrec[f].point)(va[0].ascardinalext, va[1].ascardinalext, va[2].ascardinalext, va[3].ascardinalext, va[4].ascardinalext);
                  6:
                    Result.state :=
                      TVarFunc6iext(extlangrec[f].point)(va[0].ascardinalext, va[1].ascardinalext, va[2].ascardinalext, va[3].ascardinalext, va[4].ascardinalext, va[5].ascardinalext);
                  7:
                    Result.state :=
                      TVarFunc7iext(extlangrec[f].point)(va[0].ascardinalext, va[1].ascardinalext, va[2].ascardinalext, va[3].ascardinalext, va[4].ascardinalext, va[5].ascardinalext, va[6].ascardinalext);

                  end;
                end;


              _pword:
                begin
                case Length(extlangrec[f].params) of
                  0:
                    Result.state := TVarFunc0iext(extlangrec[f].point);
                  1:
                    Result.state :=
                      TVarFunc1iext(extlangrec[f].point)(va[0].ascardinalext);
                  2:
                    Result.state :=
                      TVarFunc2iext(extlangrec[f].point)(va[0].ascardinalext, va[1].ascardinalext);
                  3:
                    Result.state :=
                      TVarFunc3iext(extlangrec[f].point)(va[0].ascardinalext, va[1].ascardinalext, va[2].ascardinalext);
                  4:
                    Result.state :=
                      TVarFunc4iext(extlangrec[f].point)(va[0].ascardinalext, va[1].ascardinalext, va[2].ascardinalext, va[3].ascardinalext);
                  5:
                    Result.state :=
                      TVarFunc5iext(extlangrec[f].point)(va[0].ascardinalext, va[1].ascardinalext, va[2].ascardinalext, va[3].ascardinalext, va[4].ascardinalext);
                  6:
                    Result.state :=
                      TVarFunc6iext(extlangrec[f].point)(va[0].ascardinalext, va[1].ascardinalext, va[2].ascardinalext, va[3].ascardinalext, va[4].ascardinalext, va[5].ascardinalext);
                  7:
                    Result.state :=
                      TVarFunc7iext(extlangrec[f].point)(va[0].ascardinalext, va[1].ascardinalext, va[2].ascardinalext, va[3].ascardinalext, va[4].ascardinalext, va[5].ascardinalext, va[6].ascardinalext);

                  end;
                end;


              _word:
                begin
                case Length(extlangrec[f].params) of
                  0:
                    Result.state := TVarFunc0iext(extlangrec[f].point);
                  1:
                    Result.state :=
                      TVarFunc1iext(extlangrec[f].point)(va[0].ascardinalext);
                  2:
                    Result.state :=
                      TVarFunc2iext(extlangrec[f].point)(va[0].ascardinalext, va[1].ascardinalext);
                  3:
                    Result.state :=
                      TVarFunc3iext(extlangrec[f].point)(va[0].ascardinalext, va[1].ascardinalext, va[2].ascardinalext);
                  4:
                    Result.state :=
                      TVarFunc4iext(extlangrec[f].point)(va[0].ascardinalext, va[1].ascardinalext, va[2].ascardinalext, va[3].ascardinalext);
                  5:
                    begin
                    Result.state :=
                      TVarFunc5iext(extlangrec[f].point)(va[0].ascardinalext, va[1].ascardinalext, va[2].ascardinalext, va[3].ascardinalext, va[4].ascardinalext);
                    end;
                  6:
                    Result.state :=
                      TVarFunc6iext(extlangrec[f].point)(va[0].ascardinalext, va[1].ascardinalext, va[2].ascardinalext, va[3].ascardinalext, va[4].ascardinalext, va[5].ascardinalext);
                  7:
                    Result.state :=
                      TVarFunc7iext(extlangrec[f].point)(va[0].ascardinalext, va[1].ascardinalext, va[2].ascardinalext, va[3].ascardinalext, va[4].ascardinalext, va[5].ascardinalext, va[6].ascardinalext);

                  end;
                end;


              _bool:
                begin
                case Length(extlangrec[f].params) of
                  0:
                    Result.state := TVarFunc0bext(extlangrec[f].point);
                  1:
                    Result.state :=
                      TVarFunc1bext(extlangrec[f].point)(va[0].ascardinalext);
                  2:
                    Result.state :=
                      TVarFunc2bext(extlangrec[f].point)(va[0].ascardinalext, va[1].ascardinalext);
                  3:
                    Result.state :=
                      TVarFunc3bext(extlangrec[f].point)(va[0].ascardinalext, va[1].ascardinalext, va[2].ascardinalext);
                  4:
                    Result.state :=
                      TVarFunc4bext(extlangrec[f].point)(va[0].ascardinalext, va[1].ascardinalext, va[2].ascardinalext, va[3].ascardinalext);
                  5:
                    Result.state :=
                      TVarFunc5bext(extlangrec[f].point)(va[0].ascardinalext, va[1].ascardinalext, va[2].ascardinalext, va[3].ascardinalext, va[4].ascardinalext);
                  6:
                    Result.state :=
                      TVarFunc6bext(extlangrec[f].point)(va[0].ascardinalext, va[1].ascardinalext, va[2].ascardinalext, va[3].ascardinalext, va[4].ascardinalext, va[5].ascardinalext);
                  7:
                    Result.state :=
                      TVarFunc7bext(extlangrec[f].point)(va[0].ascardinalext, va[1].ascardinalext, va[2].ascardinalext, va[3].ascardinalext, va[4].ascardinalext, va[5].ascardinalext, va[6].ascardinalext);
                  end;
                end;

              end;

            end;
          fixpointers(va);

          end;
        end;

      end;
    end;
end;

function TFScript.oneline;
var
  Name, s, s1, s2, s3, s4: string;
  typ: Tvartyp;
  style: tvarstyle;
  state: variant;
var
  va, va_: TVarArray;
  jump: smallint;
  oper: (menshe, bolshe, ravno, neravno, mensheravno, bolsheravno);
  doif, dowhile, mustdeclare: boolean;
  vr: TOneVar;
begin
  if indebug then
    fdcmain.Memo.Text := Format('%d: %s', [currentline, line]);
  jump := -1;
  nextline := '';
  if line = '' then
    begin
    Inc(currentline);
    exit;
    end;
  Debug(Format('[%d]:  %s', [currentline, line]), False);

  if lowercase(line) = 'begin' then
    begin
    {---------------------------------}
    end
  else
  if lowercase(line) = 'end' then
    begin
    if substate <> -1 then
      begin
      jump := return_while[substate];
      end
    else
      begin
      Result := dverror;
      log(' end   ' + IntToStr(currentline) + '?', True);
      log(' end,        ' +
        IntToStr(currentline) + '?', True);
      end;
    end
  else    ////////////////////////////////////////// BEGIN WHILE
    begin
    if pos('while ', line) > 0 then
      begin
      Delete(line, 1, pos(line, 'while ') + 5);
      if pos('<>', line) > 0 then
        begin
        oper := neravno;
        s1 := copy(line, 1, pos('<>', line) - 1);
        Delete(line, 1, length(s1));
        Delete(line, 1, pos('<>', line) + 1);
        end
      else
      if pos('>=', line) > 0 then
        begin
        oper := bolsheravno;
        s1 := copy(line, 1, pos('>=', line) - 1);
        Delete(line, 1, length(s1));
        Delete(line, 1, pos('>=', line) + 1);
        end
      else
      if pos('<=', line) > 0 then
        begin
        oper := mensheravno;
        s1 := copy(line, 1, pos('<=', line) - 1);
        Delete(line, 1, length(s1));
        Delete(line, 1, pos('<=', line) + 1);
        end


      else
      if pos('>', line) > 0 then
        begin
        oper := bolshe;
        s1 := copy(line, 1, pos('>', line) - 1);
        Delete(line, 1, length(s1));
        Delete(line, 1, pos('>', line));
        end
      else
      if pos('<', line) > 0 then
        begin
        oper := menshe;
        s1 := copy(line, 1, pos('<', line) - 1);
        Delete(line, 1, length(s1));
        Delete(line, 1, pos('<', line));
        end
      else
      if pos('=', line) > 0 then
        begin
        oper := ravno;
        s1 := copy(line, 1, pos('=', line) - 1);
        Delete(line, 1, length(s1));
        Delete(line, 1, pos('=', line));
        end;

      s1 := trim(s1);
      s2 := copy(line, 1, pos('do', line) - 1);
      Delete(line, 1, pos('do', line) + 1);
      s2 := trim(s2);
      s3 := trim(line);
      getpureval(s1, 1, va);
      getpureval(s2, 1, va_);
      case
        oper of
        menshe:
          begin
          dowhile := va[0].state < va_[0].state;
          end;
        bolshe:
          begin
          dowhile := va[0].state > va_[0].state;
          end;
        ravno:
          begin
          dowhile := va[0].state = va_[0].state;
          end;
        neravno:
          begin
          dowhile := va[0].state <> va_[0].state;
          end;
        bolsheravno:
          begin
          dowhile := va[0].state >= va_[0].state;
          end;
        mensheravno:
          begin
          dowhile := va[0].state <= va_[0].state;
          end;

        end;
      if not dowhile then
        begin
        jump := findbeginend(currentline) + 1;
        if return_while[substate] = currentline then
          begin
          Dec(substate);
          end;
        debug(' while...', False);
        if jump = -1 then
          begin
          Result := dverror;
          log('  while,     .  ' +
            IntToStr(currentline), True);
          exit;
          end;
        end
      else
        begin
        if substate <> -1 then
          begin
          if return_while[substate] <> currentline then
            begin
            Inc(substate);
            setlength(return_while, substate + 1);
            return_while[substate] := currentline;
            end;
          end
        else
          begin
          Inc(substate);
          setlength(return_while, substate + 1);
          return_while[substate] := currentline;
          end;


        debug(' while...    ' +
          IntToStr(return_while[substate]), False);
        end;

      end
    else ////////////////////////////////////////// END WHILE
      begin
      if pos('if ', line) > 0 then
        begin
        Delete(line, 1, pos(line, 'if ') + 2);
        if pos('<>', line) > 0 then
          begin
          oper := neravno;
          s1 := copy(line, 1, pos('<>', line) - 1);
          Delete(line, 1, length(s1));
          Delete(line, 1, pos('<>', line) + 1);
          end
        else
        if pos('>', line) > 0 then
          begin
          oper := bolshe;
          s1 := copy(line, 1, pos('>', line) - 1);
          Delete(line, 1, length(s1));
          Delete(line, 1, pos('>', line));
          end
        else
        if pos('>=', line) > 0 then
          begin
          oper := bolsheravno;
          s1 := copy(line, 1, pos('>=', line) - 1);
          Delete(line, 1, length(s1));
          Delete(line, 1, pos('>=', line) + 1);
          end
        else
        if pos('<=', line) > 0 then
          begin
          oper := mensheravno;
          s1 := copy(line, 1, pos('<=', line) - 1);
          Delete(line, 1, length(s1));
          Delete(line, 1, pos('<=', line) + 1);
          end


        else
        if pos('<', line) > 0 then
          begin
          oper := menshe;
          s1 := copy(line, 1, pos('<', line) - 1);
          Delete(line, 1, length(s1));
          Delete(line, 1, pos('<', line));
          end
        else
        if pos('=', line) > 0 then
          begin
          oper := ravno;
          s1 := copy(line, 1, pos('=', line) - 1);
          Delete(line, 1, length(s1));
          Delete(line, 1, pos('=', line));
          end;
        s1 := trim(s1);
        s2 := copy(line, 1, pos('then ', line) - 1);
        Delete(line, 1, pos('then ', line) + 4);
        s2 := trim(s2);
        s3 := trim(line);
        if pos('else ', s3) > 0 then
          begin
          s4 := copy(s3, pos('else ', s3) + 4, length(s3));
          Delete(s3, pos('else ', s3), length(s4) + 4);
          s4 := trim(s4);
          end;
        getpureval(s1, 1, va);
        getpureval(s2, 1, va_);
        case
          oper of
          menshe:
            begin
            doif := va[0].state < va_[0].state;
            end;
          bolshe:
            begin
            doif := va[0].state > va_[0].state;
            end;
          ravno:
            begin
            doif := va[0].state = va_[0].state;
            end;
          neravno:
            begin
            doif := va[0].state <> va_[0].state;
            end;
          bolsheravno:
            begin
            doif := va[0].state >= va_[0].state;
            end;

          mensheravno:
            begin
            doif := va[0].state <= va_[0].state;
            end;

          end;

        if doif then
          begin
          nextline := s3;
          end
        else
          begin
          if s4 <> '' then
            begin
            nextline := s4;
            end;
          end;

        end
      else
        begin
        if pos(':=', line) > 0 then
          begin
          typ  := _var;
          Name := copy(line, 1, pos(':=', line) - 1);
          Delete(line, 1, pos(':=', line) + 1);
          Name := trim(Name);
          s := trim(line);
          mustdeclare := getvar(Name, style, typ, state) = dvError;
          if mustdeclare then
            begin
            log(Format('  : "%s"', [Name]), False);
            log(Format(
              '     : "%s"',
              [Name]), False);
            log(Format('  "var %s:  = %s"', [Name, s]), False);
            end;
          if s <> '' then
            begin
            if getpureval(s, 1, va) = dvok then
              begin
              case style of

                _pint:
                  begin
                  if VarType(va[0].state) in [varInteger, varLongWord, varBoolean] then
                    state :=
                      VarAsType(VarEnsureRange(va[0].state, minlongint, maxlongint),
                      varInteger)
                  else
                  if VarIsStr(va[0].state) then
                    begin
                    state := (StrToIntDef(VarAsType(va[0].state, VarString), -1));
                    end
                  else
                    begin
                    Log(' Integer!', True);
                    Result := dverror;
                    state  := 0;
                    end;
                  end;


                _pword:
                  begin
                  if VarType(va[0].state) in [varLongWord, varInteger, varBoolean] then
                    state :=
                      VarAsType(VarEnsureRange(va[0].state, minlongword, maxlongword),
                      VarLongWord)
                  else
                  if variants.VarIsStr(va[0].state) then
                    begin
                    state :=
                      (StrToCardinalDef(VarAsType(va[0].state, varString), 0));
                    end
                  else
                    begin
                    Log(' Word!', True);
                    Result := dverror;
                    state  := 0;
                    end;
                  end;


                _word:
                  begin
                  if VarType(va[0].state) in [varLongWord, varInteger, varBoolean] then
                    state :=
                      VarAsType(VarEnsureRange(va[0].state, minlongword, maxlongword),
                      VarLongWord)
                  else
                  if variants.VarIsStr(va[0].state) then
                    begin
                    state :=
                      (StrToCardinalDef(VarAsType(va[0].state, varString), 0));

                    end
                  else
                    begin
                    Log(' Word!', True);
                    Result := dverror;
                    state  := 0;
                    end;
                  end;

                _int:
                  begin
                  if vartype(va[0].state) in [varInteger, varLongWord, varBoolean] then
                    state :=
                      VarAsType(VarEnsureRange(va[0].state, minlongint, maxlongint),
                      varInteger)
                  else
                  if variants.VarIsStr(va[0].state) then
                    begin
                    state := (StrToIntDef(VarAsType(va[0].state, varString), -1));

                    end
                  else
                    begin
                    Log(' Integer!', True);
                    Result := dverror;
                    state  := -1;
                    end;
                  end;
                _str:
                  begin
                  if (vartype(va[0].state) = varString) or
                    (vartype(va[0].state) = varLongWord) or
                    (vartype(va[0].state) = varInteger) then
                    state := VarAsType(va[0].state, varString)
                  else
                    begin
                    Log(' String!', True);
                    Result := dverror;
                    state  := '';
                    end;
                  end;
                _bool:
                  begin
                  if variants.VarIsStr(va[0].state) then
                    state := StrToBoolDef(VarAsType(va[0].state, varString), False)
                  else
                  if variants.VarIsType(va[0].state, varBoolean) then
                    state := boolean(VarAsType(va[0].state, varBoolean))
                  else
                  if variants.VarIsOrdinal(va[0].state) then
                    state := boolean(va[0].state)
                  else
                    begin
                    Log(' Boolean!', True);
                    Result := dverror;
                    state  := False;
                    end;
                  end;
                end;
              end
            else
              begin
              log('  ,  -...', True);
              Result := dverror;
              case style of

                _pint:
                  begin
                  state := 0;
                  end;


                _pword:
                  begin
                  state := 0;
                  end;

                _word:
                  begin
                  state := 0;
                  end;

                _int:
                  begin
                  state := -1;
                  end;
                _str:
                  begin
                  state := '';
                  end;
                _bool:
                  begin
                  state := False;
                  end;
                end;
              end;
            end;

          if mustdeclare then
            begin
            addvar(Name, va[0].style, _var, state);
            setvar(Name, va[0].style, _var, state);
            end
          else
            begin
            setvar(Name, style, typ, state);
            end;
          end
        else
          begin
          if (pos('goto ', line) > 0) and ((not ((pos('''', line)) < (pos('goto ', line)))) or (pos('''', line) = 0))
          then
            begin
            Delete(line, 1, pos(line, 'goto ') + 4);
            Name := trim(line);
            GetVar(Name, style, typ, state);
            jump := state;
            end
          else
            begin
            if (pos('label ', line) > 0) and ((not ((pos('''', line)) < (pos('label ', line)))) or (pos('''', line) = 0))
            then
              begin
              Delete(line, 1, pos(line, 'label ') + 5);
              Name := trim(line);
              addvar(Name, _int, _var, currentline + 1);
              end
            else
              begin
              if ((pos('var ', line) > 0)) and ((not ((pos('''', line)) < (pos('var ', line)))) or (pos('''', line) = 0))
               then
                begin
                typ := _var;
                Delete(line, 1, pos(line, 'var ') + 3);
                Name := copy(line, 1, pos(':', line) - 1);
                Delete(line, 1, length(Name) + 1);
                Name := trim(Name);
                if pos('=', line) > 0 then
                  begin
                  s := copy(line, 1, pos('=', line) - 1);
                  end
                else
                  begin
                  s := line;
                  end;
                Delete(line, 1, length(s) + 1);
                line := trim(line);
                s := uppercase(trim(s));

                if s = 'PINTEGER' then
                  begin
                  style := _pint;
                  end
                else

                if s = 'PWORD' then
                  begin
                  style := _pword;
                  end
                else

                if s = 'WORD' then
                  begin
                  style := _word;
                  end
                else

                if s = 'INTEGER' then
                  begin
                  style := _int;
                  end
                else
                if s = 'STRING' then
                  begin
                  style := _str;
                  end
                else
                if s = 'BOOLEAN' then
                  begin
                  style := _bool;
                  end
                else
                  begin
                  style  := _err;
                  Result := dverror;
                  Log('  ' + s + '?', True);
                  end;
                if line <> '' then
                  begin
                  if getpureval(line, 1, va) = dvok then
                    begin
                    case style of
                      _pint:
                        begin

                        case VarType(va[0].state) of
                          varInteger, varLongWord:
                            state :=
                              VarAsType(VarEnsureRange(va[0].state,
                              minlongint, maxlongint), varInteger);
                          varString:
                            state :=
                              StrToIntDef(VarAsType(va[0].state, varString), -1);
                          else
                            state := -1;
                          end;

                        end;


                      _pword:
                        begin
                        case VarType(va[0].state) of
                          varInteger, varLongWord:
                            state :=
                              VarAsType(VarEnsureRange(va[0].state,
                              minlongword, maxlongword), varLongWord);
                          varString:
                            state :=
                              StrToCardinalDef(VarAsType(va[0].state, varString), 0);
                          else
                            state := 0;
                          end;

                        end;

                      _word:
                        begin
                        case VarType(va[0].state) of
                          varInteger, varLongWord:
                            state :=
                              VarAsType(VarEnsureRange(va[0].state,
                              minlongword, maxlongword), varLongWord);
                          varString:
                            state :=
                              StrToCardinalDef(VarAsType(va[0].state, varString), 0);
                          else
                            state := 0;
                          end;

                        end;

                      _int:
                        begin

                        case VarType(va[0].state) of
                          varInteger, varLongWord:
                            state :=
                              VarAsType(VarEnsureRange(va[0].state,
                              minlongint, maxlongint), varInteger);
                          varString:
                            state :=
                              StrToIntDef(VarAsType(va[0].state, varString), -1);
                          else
                            state := -1;
                          end;

                        end;
                      _str:
                        begin

                        case VarType(va[0].state) of
                          varInteger:
                            state :=
                              IntToStr(VarAsType(va[0].state, varInteger));
                          varLongWord:
                            state := VarAsType(va[0].state, varString);
                          varString:
                            state := VarAsType(va[0].state, varString);
                          else
                            state := '';
                          end;

                        end;

                      _bool:
                        begin
                        state := VarAsType(va[0].state, varBoolean);
                        end;
                      end;
                    end
                  else
                    begin
                    case style of
                      _pint:
                        begin
                        state := 0;
                        end;


                      _pword:
                        begin
                        state := 0;
                        end;

                      _word:
                        begin
                        state := 0;
                        end;

                      _int:
                        begin
                        state := -1;
                        end;
                      _str:
                        begin
                        state := '';
                        end;
                      _bool:
                        begin
                        state := False;
                        end;
                      end;
                    end;
                  end;

                addvar(Name, style, typ, state);
                end
              else
                begin
                vr := onefunction(line);
                if vr.Name <> '' then
                  begin
                  debug(' ''' + vr.Name + '''  ''' +
                    VarAsType(vr.state, varString) + '''', False);
                  end
                else
                  begin
                  Result := dverror;
                  Log('    ' +
                    IntToStr(currentline) + ': ''' + line + '''', True);
                  end;
                end;
              end;
            end;
          end;
        end;
      end;
    end;


  if jump <> -1 then
    begin
    currentline := jump;
    end
  else
    begin
    if nextline = '' then
      begin
      Inc(currentline);
      end;
    end;
  Result := dvok;
end;


destructor TFscript.Destroy;
var
  n: integer;
begin
  Script.Free;
  SetLength(vars, 0);
  OnDebug := nil;
  Onerror := nil;
  reg.Free;
  if Length(extlangrec) > 0 then
    begin

    for n := 0 to Length(extlangrec) - 1 do
      begin
      FreeLibrary(ExtLangrec[n].libh);
      end;

    end;


  inherited;
end;

constructor TFscript.Create;
begin
  Script := TStringList.Create;
  Script.AddStrings(Lines);
  varc := 0;
  substate := -1;
  return := -1;
  Setlength(vars, 0);
  reg := Tdarkregistry.Create;
  addvar('_ntserviceauto', _int, _var, 2);
  addvar('_ntservicemanual', _int, _var, 3);
  addvar('_ntservicedisabled', _int, _var, 4);
  randomize();
  inherited Create;
end;

function TFScript.Run;
begin
  if preprocess = dvok then
    begin
    currentline := 0;
    Result := dvok;
    linecount := script.Count;

    while currentline < linecount do

      begin

      if nextline = '' then
        begin
        nextline := FixEnv(Trim(script[currentline]));
        end;
      Return := DvOK;
      if (oneline(nextline) = dverror) or (Return = DvError) then
        begin
        currentline := linecount;
        Result := dverror;
        end;

      end;
    log(' .', False);
    end
  else
    begin
    Result := dverror;
    log('  .  !', True);
    end;
end;

function fixenv (s: string): string;
var
  i, j: integer;
  new, v: string;
begin
  i := pos('//', s);
  if i > 0 then
    Delete(s, i, 1024);
  s := trim(s);
  Result := s;
  repeat
    i := pos('%', s);
    if i = 0 then
      continue;
    j := posex('%', s, i + 1);
    if j = 0 then
      continue;
    v := lowercase(copy(s, i + 1, j - 1 - i));
    if v <> 'fdcdir' then
      new := SysUtils.GetEnvironmentVariable(v)
    else
      new := extractfiledir(mypath);
    s := ansireplacestr(s, copy(s, i, j - i + 1), new);
  until i = 0;
  Result := s;
end;


function tfscript.registerprocedure (proc: pointer; Name: string;
  params: array of tvarstyle): boolean;
var
  i: integer;
begin
  SetLength(langrec, high(langrec) + 2);
  langrec[high(langrec)].Name  := Name;
  langrec[high(langrec)].point := proc;
  langrec[high(langrec)].calltype := _proc;
  langrec[high(langrec)].Result := _err;
  SetLength(langrec[high(langrec)].params, sizeof(params));
  if length(params) > 0 then
    for I := 0 to high(params) do
      langrec[high(langrec)].params[i] := params[i];

end;


function tfscript.registerfunction (proc: pointer; Name: string;
  params: array of tvarstyle; resulttype: tvarstyle): boolean;
var
  i: integer;
begin
  SetLength(langrec, high(langrec) + 2);
  langrec[high(langrec)].Name  := Name;
  langrec[high(langrec)].point := proc;
  langrec[high(langrec)].calltype := _func;
  langrec[high(langrec)].Result := resulttype;
  SetLength(langrec[high(langrec)].params, sizeof(params));
  if length(params) > 0 then

    for I := 0 to high(params) do
      langrec[high(langrec)].params[i] := params[i];

end;


function tfscript.registerextprocedure (Name: string; params: array of tvarstyle;
  lib: string): boolean;
var
  i: integer;
begin

  SetLength(extlangrec, high(extlangrec) + 2);
  extlangrec[high(extlangrec)].libh  := loadlibrary(PChar(lib));
  extlangrec[high(extlangrec)].Name  := Name;
  extlangrec[high(extlangrec)].point :=
    GetProcAddress(extlangrec[high(extlangrec)].libh, PChar(Name));
  extlangrec[high(extlangrec)].calltype := _proc;
  extlangrec[high(extlangrec)].Result := _err;
  SetLength(extlangrec[high(extlangrec)].params, sizeof(params));
  if length(params) > 0 then
    for I := 0 to high(params) do
      extlangrec[high(extlangrec)].params[i] := params[i];

end;

function tfscript.registerextfunction (Name: string; params: array of tvarstyle;
  resulttype: tvarstyle; lib: string): boolean;
var
  i: integer;
begin

  SetLength(extlangrec, high(extlangrec) + 2);
  extlangrec[high(extlangrec)].libh  := loadlibrary(PChar(lib));
  extlangrec[high(extlangrec)].Name  := Name;
  extlangrec[high(extlangrec)].point :=
    GetProcAddress(extlangrec[high(extlangrec)].libh, PChar(Name));
  extlangrec[high(extlangrec)].calltype := _func;
  extlangrec[high(extlangrec)].Result := resulttype;
  SetLength(extlangrec[high(extlangrec)].params, sizeof(params));
  if length(params) > 0 then

    for I := 0 to high(params) do
      extlangrec[high(extlangrec)].params[i] := params[i];

end;


procedure tfscript.fixpointers (var va: TVarArray);
var
  i: integer;
begin

  for i := 0 to length(va) - 1 do
    begin
    if va[i].needgetpw then
      begin
      va[i].state := va[i].statepw;
      if va[i].return_name <> '' then
        SetVar(va[i].return_name, va[i].style, _var, va[i].state);
      va[i].needgetpw := False;
      end;

    if va[i].needgetpi then
      begin
      va[i].state := va[i].statepi;
      if va[i].return_name <> '' then
        SetVar(va[i].return_name, va[i].style, _var, va[i].state);
      va[i].needgetpi := False;
      end;

    end;

end;


initialization


finalization


end.
